/* sega-cd-header.c generated by valac 0.44.3, the Vala compiler
 * generated from sega-cd-header.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/
/* Documentation: https://en.wikibooks.org/wiki/Genesis_Programming*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "gnome-games.h"
#include <stdlib.h>
#include <string.h>

#define GAMES_TYPE_SEGA_CD_HEADER (games_sega_cd_header_get_type ())
#define GAMES_SEGA_CD_HEADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_SEGA_CD_HEADER, GamesSegaCDHeader))
#define GAMES_SEGA_CD_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_SEGA_CD_HEADER, GamesSegaCDHeaderClass))
#define GAMES_IS_SEGA_CD_HEADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_SEGA_CD_HEADER))
#define GAMES_IS_SEGA_CD_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_SEGA_CD_HEADER))
#define GAMES_SEGA_CD_HEADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_SEGA_CD_HEADER, GamesSegaCDHeaderClass))

typedef struct _GamesSegaCDHeader GamesSegaCDHeader;
typedef struct _GamesSegaCDHeaderClass GamesSegaCDHeaderClass;
typedef struct _GamesSegaCDHeaderPrivate GamesSegaCDHeaderPrivate;
typedef enum  {
	GAMES_SEGA_CD_SYSTEM_INVALID,
	GAMES_SEGA_CD_SYSTEM_SEGA_CD,
	GAMES_SEGA_CD_SYSTEM_SEGA_CD_32X
} GamesSegaCDSystem;

#define GAMES_TYPE_SEGA_CD_SYSTEM (games_sega_cd_system_get_type ())
enum  {
	GAMES_SEGA_CD_HEADER_0_PROPERTY,
	GAMES_SEGA_CD_HEADER_SYSTEM_PROPERTY,
	GAMES_SEGA_CD_HEADER_NUM_PROPERTIES
};
static GParamSpec* games_sega_cd_header_properties[GAMES_SEGA_CD_HEADER_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GamesSegaCDHeader {
	GObject parent_instance;
	GamesSegaCDHeaderPrivate * priv;
};

struct _GamesSegaCDHeaderClass {
	GObjectClass parent_class;
};

struct _GamesSegaCDHeaderPrivate {
	GamesSegaCDSystem* _system;
	GFile* file;
	gsize* offset;
};

typedef enum  {
	GAMES_SEGA_CD_ERROR_INVALID_HEADER,
	GAMES_SEGA_CD_ERROR_INVALID_CUE_SHEET,
	GAMES_SEGA_CD_ERROR_INVALID_FILE_TYPE
} GamesSegaCDError;
#define GAMES_SEGA_CD_ERROR games_sega_cd_error_quark ()

static gint GamesSegaCDHeader_private_offset;
static gpointer games_sega_cd_header_parent_class = NULL;
static GType games_sega_cd_header_type_id = 0;

GType games_sega_cd_header_register_type (GTypeModule * module);
GType games_sega_cd_header_get_type (void) G_GNUC_CONST;
GType games_sega_cd_system_get_type (void) G_GNUC_CONST;
#define GAMES_SEGA_CD_HEADER_HEADER_LENGTH ((gsize) 0x200)
#define GAMES_SEGA_CD_HEADER_CD_OFFSET ((gsize) 0x0)
#define GAMES_SEGA_CD_HEADER_SYSTEM_OFFSET ((gsize) 0x100)
#define GAMES_SEGA_CD_HEADER_SYSTEM_SIZE ((gsize) 0xf)
GamesSegaCDHeader* games_sega_cd_header_new (GFile* file);
GamesSegaCDHeader* games_sega_cd_header_construct (GType object_type,
                                                   GFile* file);
void games_sega_cd_header_check_validity (GamesSegaCDHeader* self,
                                          GError** error);
GamesSegaCDSystem games_sega_cd_header_get_system (GamesSegaCDHeader* self);
GQuark games_sega_cd_error_quark (void);
gsize games_sega_cd_header_get_offset (GamesSegaCDHeader* self,
                                       GError** error);
static gsize* _size_t_dup (gsize* self);
static GamesSegaCDSystem games_sega_cd_header_parse_system (GamesSegaCDHeader* self,
                                                     GError** error);
gboolean games_sega_cd_header_is_sega_cd (GamesSegaCDHeader* self);
gboolean games_sega_cd_header_is_sega_cd_32x (GamesSegaCDHeader* self);
static GamesSegaCDSystem* _games_sega_cd_system_dup (GamesSegaCDSystem* self);
static void games_sega_cd_header_finalize (GObject * obj);
static void _vala_games_sega_cd_header_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);

static const gsize GAMES_SEGA_CD_HEADER_POSSIBLE_HEADER_OFFSETS[2] = {(gsize) 0x0, (gsize) 0x10};

static inline gpointer
games_sega_cd_header_get_instance_private (GamesSegaCDHeader* self)
{
	return G_STRUCT_MEMBER_P (self, GamesSegaCDHeader_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../plugins/sega-cd/src/sega-cd-header.vala"
	return self ? g_object_ref (self) : NULL;
#line 110 "sega-cd-header.c"
}

GamesSegaCDHeader*
games_sega_cd_header_construct (GType object_type,
                                GFile* file)
{
	GamesSegaCDHeader * self = NULL;
	GFile* _tmp0_;
#line 38 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 38 "../plugins/sega-cd/src/sega-cd-header.vala"
	self = (GamesSegaCDHeader*) g_object_new (object_type, NULL);
#line 39 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 39 "../plugins/sega-cd/src/sega-cd-header.vala"
	_g_object_unref0 (self->priv->file);
#line 39 "../plugins/sega-cd/src/sega-cd-header.vala"
	self->priv->file = _tmp0_;
#line 38 "../plugins/sega-cd/src/sega-cd-header.vala"
	return self;
#line 131 "sega-cd-header.c"
}

GamesSegaCDHeader*
games_sega_cd_header_new (GFile* file)
{
#line 38 "../plugins/sega-cd/src/sega-cd-header.vala"
	return games_sega_cd_header_construct (GAMES_TYPE_SEGA_CD_HEADER, file);
#line 139 "sega-cd-header.c"
}

void
games_sega_cd_header_check_validity (GamesSegaCDHeader* self,
                                     GError** error)
{
	GamesSegaCDSystem _tmp0_;
	GamesSegaCDSystem _tmp1_;
	GError* _inner_error0_ = NULL;
#line 42 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_return_if_fail (self != NULL);
#line 43 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp0_ = games_sega_cd_header_get_system (self);
#line 43 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp1_ = _tmp0_;
#line 43 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (_tmp1_ == GAMES_SEGA_CD_SYSTEM_INVALID) {
#line 157 "sega-cd-header.c"
		GError* _tmp2_;
#line 44 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp2_ = g_error_new_literal (GAMES_SEGA_CD_ERROR, GAMES_SEGA_CD_ERROR_INVALID_HEADER, _ ("The file doesn’t have a Genesis/Sega 32X/Sega CD/Sega Pico header."));
#line 44 "../plugins/sega-cd/src/sega-cd-header.vala"
		_inner_error0_ = _tmp2_;
#line 44 "../plugins/sega-cd/src/sega-cd-header.vala"
		g_propagate_error (error, _inner_error0_);
#line 44 "../plugins/sega-cd/src/sega-cd-header.vala"
		return;
#line 167 "sega-cd-header.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 192 "sega-cd-header.c"
}

static gsize*
_size_t_dup (gsize* self)
{
	gsize* dup;
#line 57 "../plugins/sega-cd/src/sega-cd-header.vala"
	dup = g_new0 (gsize, 1);
#line 57 "../plugins/sega-cd/src/sega-cd-header.vala"
	memcpy (dup, self, sizeof (gsize));
#line 57 "../plugins/sega-cd/src/sega-cd-header.vala"
	return dup;
#line 205 "sega-cd-header.c"
}

static gpointer
__size_t_dup0 (gpointer self)
{
#line 57 "../plugins/sega-cd/src/sega-cd-header.vala"
	return self ? _size_t_dup (self) : NULL;
#line 213 "sega-cd-header.c"
}

gsize
games_sega_cd_header_get_offset (GamesSegaCDHeader* self,
                                 GError** error)
{
	gsize result = 0UL;
	gsize* _tmp0_;
	GamesStringInputStream* stream = NULL;
	GFile* _tmp2_;
	GamesStringInputStream* _tmp3_;
	GError* _tmp12_;
	gsize _tmp13_ = 0UL;
	GError* _inner_error0_ = NULL;
#line 47 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 48 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp0_ = self->priv->offset;
#line 48 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (_tmp0_ != NULL) {
#line 234 "sega-cd-header.c"
		gsize* _tmp1_;
#line 49 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp1_ = self->priv->offset;
#line 49 "../plugins/sega-cd/src/sega-cd-header.vala"
		result = *_tmp1_;
#line 49 "../plugins/sega-cd/src/sega-cd-header.vala"
		return result;
#line 242 "sega-cd-header.c"
	}
#line 51 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp2_ = self->priv->file;
#line 51 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp3_ = games_string_input_stream_new (_tmp2_);
#line 51 "../plugins/sega-cd/src/sega-cd-header.vala"
	stream = _tmp3_;
#line 250 "sega-cd-header.c"
	{
		gsize* possible_offset_collection = NULL;
		gint possible_offset_collection_length1 = 0;
		gint _possible_offset_collection_size_ = 0;
		gint possible_offset_it = 0;
#line 53 "../plugins/sega-cd/src/sega-cd-header.vala"
		possible_offset_collection = GAMES_SEGA_CD_HEADER_POSSIBLE_HEADER_OFFSETS;
#line 53 "../plugins/sega-cd/src/sega-cd-header.vala"
		possible_offset_collection_length1 = G_N_ELEMENTS (GAMES_SEGA_CD_HEADER_POSSIBLE_HEADER_OFFSETS);
#line 53 "../plugins/sega-cd/src/sega-cd-header.vala"
		for (possible_offset_it = 0; possible_offset_it < G_N_ELEMENTS (GAMES_SEGA_CD_HEADER_POSSIBLE_HEADER_OFFSETS); possible_offset_it = possible_offset_it + 1) {
#line 262 "sega-cd-header.c"
			gsize possible_offset = 0UL;
#line 53 "../plugins/sega-cd/src/sega-cd-header.vala"
			possible_offset = possible_offset_collection[possible_offset_it];
#line 266 "sega-cd-header.c"
			{
				gchar* system_string = NULL;
				GamesStringInputStream* _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				const gchar* _tmp9_;
#line 54 "../plugins/sega-cd/src/sega-cd-header.vala"
				_tmp4_ = stream;
#line 54 "../plugins/sega-cd/src/sega-cd-header.vala"
				_tmp5_ = games_string_input_stream_read_string_for_size (_tmp4_, possible_offset + GAMES_SEGA_CD_HEADER_SYSTEM_OFFSET, GAMES_SEGA_CD_HEADER_SYSTEM_SIZE, &_inner_error0_);
#line 54 "../plugins/sega-cd/src/sega-cd-header.vala"
				system_string = _tmp5_;
#line 54 "../plugins/sega-cd/src/sega-cd-header.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "sega-cd-header.c"
					gsize _tmp6_ = 0UL;
#line 54 "../plugins/sega-cd/src/sega-cd-header.vala"
					g_propagate_error (error, _inner_error0_);
#line 54 "../plugins/sega-cd/src/sega-cd-header.vala"
					_g_object_unref0 (stream);
#line 54 "../plugins/sega-cd/src/sega-cd-header.vala"
					return _tmp6_;
#line 290 "sega-cd-header.c"
				}
#line 55 "../plugins/sega-cd/src/sega-cd-header.vala"
				_tmp7_ = system_string;
#line 55 "../plugins/sega-cd/src/sega-cd-header.vala"
				_tmp8_ = string_strip (_tmp7_);
#line 55 "../plugins/sega-cd/src/sega-cd-header.vala"
				_g_free0 (system_string);
#line 55 "../plugins/sega-cd/src/sega-cd-header.vala"
				system_string = _tmp8_;
#line 56 "../plugins/sega-cd/src/sega-cd-header.vala"
				_tmp9_ = system_string;
#line 56 "../plugins/sega-cd/src/sega-cd-header.vala"
				if (g_str_has_prefix (_tmp9_, "SEGA")) {
#line 304 "sega-cd-header.c"
					gsize* _tmp10_;
					gsize* _tmp11_;
#line 57 "../plugins/sega-cd/src/sega-cd-header.vala"
					_tmp10_ = __size_t_dup0 (&possible_offset);
#line 57 "../plugins/sega-cd/src/sega-cd-header.vala"
					_g_free0 (self->priv->offset);
#line 57 "../plugins/sega-cd/src/sega-cd-header.vala"
					self->priv->offset = _tmp10_;
#line 59 "../plugins/sega-cd/src/sega-cd-header.vala"
					_tmp11_ = self->priv->offset;
#line 59 "../plugins/sega-cd/src/sega-cd-header.vala"
					result = *_tmp11_;
#line 59 "../plugins/sega-cd/src/sega-cd-header.vala"
					_g_free0 (system_string);
#line 59 "../plugins/sega-cd/src/sega-cd-header.vala"
					_g_object_unref0 (stream);
#line 59 "../plugins/sega-cd/src/sega-cd-header.vala"
					return result;
#line 323 "sega-cd-header.c"
				}
#line 53 "../plugins/sega-cd/src/sega-cd-header.vala"
				_g_free0 (system_string);
#line 327 "sega-cd-header.c"
			}
		}
	}
#line 63 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp12_ = g_error_new_literal (GAMES_SEGA_CD_ERROR, GAMES_SEGA_CD_ERROR_INVALID_HEADER, _ ("The file doesn’t have a Genesis/Sega 32X/Sega CD/Sega Pico header."));
#line 63 "../plugins/sega-cd/src/sega-cd-header.vala"
	_inner_error0_ = _tmp12_;
#line 63 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_propagate_error (error, _inner_error0_);
#line 63 "../plugins/sega-cd/src/sega-cd-header.vala"
	_g_object_unref0 (stream);
#line 63 "../plugins/sega-cd/src/sega-cd-header.vala"
	return _tmp13_;
#line 341 "sega-cd-header.c"
}

static gchar*
string_chomp (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1291 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1292 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1292 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1293 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1293 "glib-2.0.vapi"
	g_strchomp (_tmp1_);
#line 1294 "glib-2.0.vapi"
	result = _result_;
#line 1294 "glib-2.0.vapi"
	return result;
#line 365 "sega-cd-header.c"
}

static GamesSegaCDSystem
games_sega_cd_header_parse_system (GamesSegaCDHeader* self,
                                   GError** error)
{
	GamesSegaCDSystem result = 0;
	GamesStringInputStream* stream = NULL;
	GFile* _tmp0_;
	GamesStringInputStream* _tmp1_;
	gsize offset = 0UL;
	gboolean _tmp2_ = FALSE;
	GamesStringInputStream* _tmp3_;
	gchar* system_string = NULL;
	GamesStringInputStream* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GQuark _tmp11_ = 0U;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	static GQuark _tmp10_label0 = 0;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	static GQuark _tmp10_label1 = 0;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	static GQuark _tmp10_label2 = 0;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	static GQuark _tmp10_label3 = 0;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	static GQuark _tmp10_label4 = 0;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	static GQuark _tmp10_label5 = 0;
#line 399 "sega-cd-header.c"
	GError* _inner_error0_ = NULL;
#line 66 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 67 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp0_ = self->priv->file;
#line 67 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp1_ = games_string_input_stream_new (_tmp0_);
#line 67 "../plugins/sega-cd/src/sega-cd-header.vala"
	stream = _tmp1_;
#line 69 "../plugins/sega-cd/src/sega-cd-header.vala"
	offset = games_sega_cd_header_get_offset (self, &_inner_error0_);
#line 69 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../plugins/sega-cd/src/sega-cd-header.vala"
		g_propagate_error (error, _inner_error0_);
#line 69 "../plugins/sega-cd/src/sega-cd-header.vala"
		_g_object_unref0 (stream);
#line 69 "../plugins/sega-cd/src/sega-cd-header.vala"
		return 0;
#line 419 "sega-cd-header.c"
	}
#line 70 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp3_ = stream;
#line 70 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp2_ = games_string_input_stream_has_string (_tmp3_, offset + GAMES_SEGA_CD_HEADER_CD_OFFSET, "SEGADISCSYSTEM", &_inner_error0_);
#line 70 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../plugins/sega-cd/src/sega-cd-header.vala"
		g_propagate_error (error, _inner_error0_);
#line 70 "../plugins/sega-cd/src/sega-cd-header.vala"
		_g_object_unref0 (stream);
#line 70 "../plugins/sega-cd/src/sega-cd-header.vala"
		return 0;
#line 433 "sega-cd-header.c"
	}
#line 70 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (!_tmp2_) {
#line 71 "../plugins/sega-cd/src/sega-cd-header.vala"
		result = GAMES_SEGA_CD_SYSTEM_INVALID;
#line 71 "../plugins/sega-cd/src/sega-cd-header.vala"
		_g_object_unref0 (stream);
#line 71 "../plugins/sega-cd/src/sega-cd-header.vala"
		return result;
#line 443 "sega-cd-header.c"
	}
#line 73 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp4_ = stream;
#line 73 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp5_ = games_string_input_stream_read_string_for_size (_tmp4_, offset + GAMES_SEGA_CD_HEADER_SYSTEM_OFFSET, GAMES_SEGA_CD_HEADER_SYSTEM_SIZE, &_inner_error0_);
#line 73 "../plugins/sega-cd/src/sega-cd-header.vala"
	system_string = _tmp5_;
#line 73 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../plugins/sega-cd/src/sega-cd-header.vala"
		g_propagate_error (error, _inner_error0_);
#line 73 "../plugins/sega-cd/src/sega-cd-header.vala"
		_g_object_unref0 (stream);
#line 73 "../plugins/sega-cd/src/sega-cd-header.vala"
		return 0;
#line 459 "sega-cd-header.c"
	}
#line 74 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp6_ = system_string;
#line 74 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp7_ = string_chomp (_tmp6_);
#line 74 "../plugins/sega-cd/src/sega-cd-header.vala"
	_g_free0 (system_string);
#line 74 "../plugins/sega-cd/src/sega-cd-header.vala"
	system_string = _tmp7_;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp8_ = system_string;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp9_ = _tmp8_;
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp11_ = (NULL == _tmp9_) ? 0 : g_quark_from_string (_tmp9_);
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (((((_tmp11_ == ((0 != _tmp10_label0) ? _tmp10_label0 : (_tmp10_label0 = g_quark_from_static_string ("SEGA MEGA DRIVE")))) || (_tmp11_ == ((0 != _tmp10_label1) ? _tmp10_label1 : (_tmp10_label1 = g_quark_from_static_string ("SEGA GENESIS"))))) || (_tmp11_ == ((0 != _tmp10_label2) ? _tmp10_label2 : (_tmp10_label2 = g_quark_from_static_string (" SEGA MEGA DRIV"))))) || (_tmp11_ == ((0 != _tmp10_label3) ? _tmp10_label3 : (_tmp10_label3 = g_quark_from_static_string ("SEGA_SEGA_CD"))))) || (_tmp11_ == ((0 != _tmp10_label4) ? _tmp10_label4 : (_tmp10_label4 = g_quark_from_static_string ("SEGA are Regist"))))) {
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
		switch (0) {
#line 479 "sega-cd-header.c"
			default:
			{
#line 82 "../plugins/sega-cd/src/sega-cd-header.vala"
				result = GAMES_SEGA_CD_SYSTEM_SEGA_CD;
#line 82 "../plugins/sega-cd/src/sega-cd-header.vala"
				_g_free0 (system_string);
#line 82 "../plugins/sega-cd/src/sega-cd-header.vala"
				_g_object_unref0 (stream);
#line 82 "../plugins/sega-cd/src/sega-cd-header.vala"
				return result;
#line 490 "sega-cd-header.c"
			}
		}
	} else if (_tmp11_ == ((0 != _tmp10_label5) ? _tmp10_label5 : (_tmp10_label5 = g_quark_from_static_string ("SEGA 32X")))) {
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
		switch (0) {
#line 496 "sega-cd-header.c"
			default:
			{
#line 84 "../plugins/sega-cd/src/sega-cd-header.vala"
				result = GAMES_SEGA_CD_SYSTEM_SEGA_CD_32X;
#line 84 "../plugins/sega-cd/src/sega-cd-header.vala"
				_g_free0 (system_string);
#line 84 "../plugins/sega-cd/src/sega-cd-header.vala"
				_g_object_unref0 (stream);
#line 84 "../plugins/sega-cd/src/sega-cd-header.vala"
				return result;
#line 507 "sega-cd-header.c"
			}
		}
	} else {
#line 76 "../plugins/sega-cd/src/sega-cd-header.vala"
		switch (0) {
#line 513 "sega-cd-header.c"
			default:
			{
#line 86 "../plugins/sega-cd/src/sega-cd-header.vala"
				result = GAMES_SEGA_CD_SYSTEM_INVALID;
#line 86 "../plugins/sega-cd/src/sega-cd-header.vala"
				_g_free0 (system_string);
#line 86 "../plugins/sega-cd/src/sega-cd-header.vala"
				_g_object_unref0 (stream);
#line 86 "../plugins/sega-cd/src/sega-cd-header.vala"
				return result;
#line 524 "sega-cd-header.c"
			}
		}
	}
#line 66 "../plugins/sega-cd/src/sega-cd-header.vala"
	_g_free0 (system_string);
#line 66 "../plugins/sega-cd/src/sega-cd-header.vala"
	_g_object_unref0 (stream);
#line 532 "sega-cd-header.c"
}

gboolean
games_sega_cd_header_is_sega_cd (GamesSegaCDHeader* self)
{
	gboolean result = FALSE;
	GamesSegaCDSystem _tmp0_;
	GamesSegaCDSystem _tmp1_;
#line 90 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp0_ = games_sega_cd_header_get_system (self);
#line 91 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp1_ = _tmp0_;
#line 91 "../plugins/sega-cd/src/sega-cd-header.vala"
	switch (_tmp1_) {
#line 91 "../plugins/sega-cd/src/sega-cd-header.vala"
		case GAMES_SEGA_CD_SYSTEM_SEGA_CD:
#line 551 "sega-cd-header.c"
		{
#line 93 "../plugins/sega-cd/src/sega-cd-header.vala"
			result = TRUE;
#line 93 "../plugins/sega-cd/src/sega-cd-header.vala"
			return result;
#line 557 "sega-cd-header.c"
		}
		default:
		{
#line 95 "../plugins/sega-cd/src/sega-cd-header.vala"
			result = FALSE;
#line 95 "../plugins/sega-cd/src/sega-cd-header.vala"
			return result;
#line 565 "sega-cd-header.c"
		}
	}
}

gboolean
games_sega_cd_header_is_sega_cd_32x (GamesSegaCDHeader* self)
{
	gboolean result = FALSE;
	GamesSegaCDSystem _tmp0_;
	GamesSegaCDSystem _tmp1_;
#line 99 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp0_ = games_sega_cd_header_get_system (self);
#line 100 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp1_ = _tmp0_;
#line 100 "../plugins/sega-cd/src/sega-cd-header.vala"
	switch (_tmp1_) {
#line 100 "../plugins/sega-cd/src/sega-cd-header.vala"
		case GAMES_SEGA_CD_SYSTEM_SEGA_CD_32X:
#line 586 "sega-cd-header.c"
		{
#line 102 "../plugins/sega-cd/src/sega-cd-header.vala"
			result = TRUE;
#line 102 "../plugins/sega-cd/src/sega-cd-header.vala"
			return result;
#line 592 "sega-cd-header.c"
		}
		default:
		{
#line 104 "../plugins/sega-cd/src/sega-cd-header.vala"
			result = FALSE;
#line 104 "../plugins/sega-cd/src/sega-cd-header.vala"
			return result;
#line 600 "sega-cd-header.c"
		}
	}
}

static GamesSegaCDSystem*
_games_sega_cd_system_dup (GamesSegaCDSystem* self)
{
	GamesSegaCDSystem* dup;
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
	dup = g_new0 (GamesSegaCDSystem, 1);
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
	memcpy (dup, self, sizeof (GamesSegaCDSystem));
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
	return dup;
#line 615 "sega-cd-header.c"
}

static gpointer
__games_sega_cd_system_dup0 (gpointer self)
{
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
	return self ? _games_sega_cd_system_dup (self) : NULL;
#line 623 "sega-cd-header.c"
}

GamesSegaCDSystem
games_sega_cd_header_get_system (GamesSegaCDHeader* self)
{
	GamesSegaCDSystem result;
	GamesSegaCDSystem* _tmp0_;
	GamesSegaCDSystem* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 18 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 19 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp0_ = self->priv->_system;
#line 19 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (_tmp0_ != NULL) {
#line 639 "sega-cd-header.c"
		GamesSegaCDSystem* _tmp1_;
#line 20 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp1_ = self->priv->_system;
#line 20 "../plugins/sega-cd/src/sega-cd-header.vala"
		result = *_tmp1_;
#line 20 "../plugins/sega-cd/src/sega-cd-header.vala"
		return result;
#line 647 "sega-cd-header.c"
	}
	{
		GamesSegaCDSystem _tmp2_ = 0;
		GamesSegaCDSystem* _tmp3_;
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp2_ = games_sega_cd_header_parse_system (self, &_inner_error0_);
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 656 "sega-cd-header.c"
			goto __catch0_g_error;
		}
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp3_ = __games_sega_cd_system_dup0 (&_tmp2_);
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
		_g_free0 (self->priv->_system);
#line 23 "../plugins/sega-cd/src/sega-cd-header.vala"
		self->priv->_system = _tmp3_;
#line 665 "sega-cd-header.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		GamesSegaCDSystem _tmp6_;
		GamesSegaCDSystem* _tmp7_;
#line 22 "../plugins/sega-cd/src/sega-cd-header.vala"
		e = _inner_error0_;
#line 22 "../plugins/sega-cd/src/sega-cd-header.vala"
		_inner_error0_ = NULL;
#line 26 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp4_ = e;
#line 26 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp5_ = _tmp4_->message;
#line 26 "../plugins/sega-cd/src/sega-cd-header.vala"
		g_debug ("sega-cd-header.vala:26: %s", _tmp5_);
#line 28 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp6_ = GAMES_SEGA_CD_SYSTEM_INVALID;
#line 28 "../plugins/sega-cd/src/sega-cd-header.vala"
		_tmp7_ = __games_sega_cd_system_dup0 (&_tmp6_);
#line 28 "../plugins/sega-cd/src/sega-cd-header.vala"
		_g_free0 (self->priv->_system);
#line 28 "../plugins/sega-cd/src/sega-cd-header.vala"
		self->priv->_system = _tmp7_;
#line 22 "../plugins/sega-cd/src/sega-cd-header.vala"
		_g_error_free0 (e);
#line 695 "sega-cd-header.c"
	}
	__finally0:
#line 22 "../plugins/sega-cd/src/sega-cd-header.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22 "../plugins/sega-cd/src/sega-cd-header.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 22 "../plugins/sega-cd/src/sega-cd-header.vala"
		g_clear_error (&_inner_error0_);
#line 22 "../plugins/sega-cd/src/sega-cd-header.vala"
		return 0;
#line 706 "sega-cd-header.c"
	}
#line 31 "../plugins/sega-cd/src/sega-cd-header.vala"
	_tmp8_ = self->priv->_system;
#line 31 "../plugins/sega-cd/src/sega-cd-header.vala"
	result = *_tmp8_;
#line 31 "../plugins/sega-cd/src/sega-cd-header.vala"
	return result;
#line 714 "sega-cd-header.c"
}

static void
games_sega_cd_header_class_init (GamesSegaCDHeaderClass * klass,
                                 gpointer klass_data)
{
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	games_sega_cd_header_parent_class = g_type_class_peek_parent (klass);
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_type_class_adjust_private_offset (klass, &GamesSegaCDHeader_private_offset);
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_sega_cd_header_get_property;
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	G_OBJECT_CLASS (klass)->finalize = games_sega_cd_header_finalize;
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SEGA_CD_HEADER_SYSTEM_PROPERTY, games_sega_cd_header_properties[GAMES_SEGA_CD_HEADER_SYSTEM_PROPERTY] = g_param_spec_enum ("system", "system", "system", GAMES_TYPE_SEGA_CD_SYSTEM, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 731 "sega-cd-header.c"
}

static void
games_sega_cd_header_instance_init (GamesSegaCDHeader * self,
                                    gpointer klass)
{
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	self->priv = games_sega_cd_header_get_instance_private (self);
#line 740 "sega-cd-header.c"
}

static void
games_sega_cd_header_finalize (GObject * obj)
{
	GamesSegaCDHeader * self;
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_SEGA_CD_HEADER, GamesSegaCDHeader);
#line 16 "../plugins/sega-cd/src/sega-cd-header.vala"
	_g_free0 (self->priv->_system);
#line 35 "../plugins/sega-cd/src/sega-cd-header.vala"
	_g_object_unref0 (self->priv->file);
#line 36 "../plugins/sega-cd/src/sega-cd-header.vala"
	_g_free0 (self->priv->offset);
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	G_OBJECT_CLASS (games_sega_cd_header_parent_class)->finalize (obj);
#line 757 "sega-cd-header.c"
}

GType
games_sega_cd_header_get_type (void)
{
	return games_sega_cd_header_type_id;
}

GType
games_sega_cd_header_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesSegaCDHeaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_sega_cd_header_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesSegaCDHeader), 0, (GInstanceInitFunc) games_sega_cd_header_instance_init, NULL };
	games_sega_cd_header_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "GamesSegaCDHeader", &g_define_type_info, 0);
	GamesSegaCDHeader_private_offset = sizeof (GamesSegaCDHeaderPrivate);
	return games_sega_cd_header_type_id;
}

static void
_vala_games_sega_cd_header_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GamesSegaCDHeader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_SEGA_CD_HEADER, GamesSegaCDHeader);
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
	switch (property_id) {
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
		case GAMES_SEGA_CD_HEADER_SYSTEM_PROPERTY:
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
		g_value_set_enum (value, games_sega_cd_header_get_system (self));
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
		break;
#line 791 "sega-cd-header.c"
		default:
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "../plugins/sega-cd/src/sega-cd-header.vala"
		break;
#line 797 "sega-cd-header.c"
	}
}

GQuark
games_sega_cd_error_quark (void)
{
	return g_quark_from_static_string ("games-sega-cd-error-quark");
}

