/* runner.c generated by valac 0.44.3, the Vala compiler
 * generated from runner.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>

#define GAMES_TYPE_RUNNER (games_runner_get_type ())
#define GAMES_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_RUNNER, GamesRunner))
#define GAMES_IS_RUNNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_RUNNER))
#define GAMES_RUNNER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GAMES_TYPE_RUNNER, GamesRunnerIface))

typedef struct _GamesRunner GamesRunner;
typedef struct _GamesRunnerIface GamesRunnerIface;
typedef enum  {
	GAMES_INPUT_MODE_NONE,
	GAMES_INPUT_MODE_KEYBOARD,
	GAMES_INPUT_MODE_GAMEPAD
} GamesInputMode;

#define GAMES_TYPE_INPUT_MODE (games_input_mode_get_type ())

#define GAMES_TYPE_MEDIA_SET (games_media_set_get_type ())
#define GAMES_MEDIA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_MEDIA_SET, GamesMediaSet))
#define GAMES_MEDIA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_MEDIA_SET, GamesMediaSetClass))
#define GAMES_IS_MEDIA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_MEDIA_SET))
#define GAMES_IS_MEDIA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_MEDIA_SET))
#define GAMES_MEDIA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_MEDIA_SET, GamesMediaSetClass))

typedef struct _GamesMediaSet GamesMediaSet;
typedef struct _GamesMediaSetClass GamesMediaSetClass;
enum  {
	GAMES_RUNNER_STOPPED_SIGNAL,
	GAMES_RUNNER_NUM_SIGNALS
};
static guint games_runner_signals[GAMES_RUNNER_NUM_SIGNALS] = {0};

struct _GamesRunnerIface {
	GTypeInterface parent_iface;
	gboolean (*check_is_valid) (GamesRunner* self, gchar* * error_message, GError** error);
	GtkWidget* (*get_display) (GamesRunner* self);
	void (*start) (GamesRunner* self, GError** error);
	void (*resume) (GamesRunner* self, GError** error);
	void (*pause) (GamesRunner* self);
	void (*stop) (GamesRunner* self);
	GamesInputMode* (*get_available_input_modes) (GamesRunner* self, gint* result_length1);
	gboolean (*get_can_fullscreen) (GamesRunner* self);
	gboolean (*get_can_quit_safely) (GamesRunner* self);
	gboolean (*get_can_resume) (GamesRunner* self);
	GamesMediaSet* (*get_media_set) (GamesRunner* self);
	GamesInputMode (*get_input_mode) (GamesRunner* self);
	void (*set_input_mode) (GamesRunner* self, GamesInputMode value);
};

GType games_input_mode_get_type (void) G_GNUC_CONST;
GType games_media_set_get_type (void) G_GNUC_CONST;
GType games_runner_get_type (void) G_GNUC_CONST;
gboolean games_runner_check_is_valid (GamesRunner* self,
                                      gchar* * error_message,
                                      GError** error);
GtkWidget* games_runner_get_display (GamesRunner* self);
void games_runner_start (GamesRunner* self,
                         GError** error);
void games_runner_resume (GamesRunner* self,
                          GError** error);
void games_runner_pause (GamesRunner* self);
void games_runner_stop (GamesRunner* self);
GamesInputMode* games_runner_get_available_input_modes (GamesRunner* self,
                                                        gint* result_length1);
gboolean games_runner_get_can_fullscreen (GamesRunner* self);
gboolean games_runner_get_can_quit_safely (GamesRunner* self);
gboolean games_runner_get_can_resume (GamesRunner* self);
GamesMediaSet* games_runner_get_media_set (GamesRunner* self);
GamesInputMode games_runner_get_input_mode (GamesRunner* self);
void games_runner_set_input_mode (GamesRunner* self,
                                  GamesInputMode value);

gboolean
games_runner_check_is_valid (GamesRunner* self,
                             gchar* * error_message,
                             GError** error)
{
#line 12 "../src/core/runner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 12 "../src/core/runner.vala"
	return GAMES_RUNNER_GET_INTERFACE (self)->check_is_valid (self, error_message, error);
#line 92 "runner.c"
}

GtkWidget*
games_runner_get_display (GamesRunner* self)
{
#line 13 "../src/core/runner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/core/runner.vala"
	return GAMES_RUNNER_GET_INTERFACE (self)->get_display (self);
#line 102 "runner.c"
}

void
games_runner_start (GamesRunner* self,
                    GError** error)
{
#line 14 "../src/core/runner.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/core/runner.vala"
	GAMES_RUNNER_GET_INTERFACE (self)->start (self, error);
#line 113 "runner.c"
}

void
games_runner_resume (GamesRunner* self,
                     GError** error)
{
#line 15 "../src/core/runner.vala"
	g_return_if_fail (self != NULL);
#line 15 "../src/core/runner.vala"
	GAMES_RUNNER_GET_INTERFACE (self)->resume (self, error);
#line 124 "runner.c"
}

void
games_runner_pause (GamesRunner* self)
{
#line 16 "../src/core/runner.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/core/runner.vala"
	GAMES_RUNNER_GET_INTERFACE (self)->pause (self);
#line 134 "runner.c"
}

void
games_runner_stop (GamesRunner* self)
{
#line 17 "../src/core/runner.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/core/runner.vala"
	GAMES_RUNNER_GET_INTERFACE (self)->stop (self);
#line 144 "runner.c"
}

GamesInputMode*
games_runner_get_available_input_modes (GamesRunner* self,
                                        gint* result_length1)
{
#line 18 "../src/core/runner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/core/runner.vala"
	return GAMES_RUNNER_GET_INTERFACE (self)->get_available_input_modes (self, result_length1);
#line 155 "runner.c"
}

gboolean
games_runner_get_can_fullscreen (GamesRunner* self)
{
#line 6 "../src/core/runner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 6 "../src/core/runner.vala"
	return GAMES_RUNNER_GET_INTERFACE (self)->get_can_fullscreen (self);
#line 165 "runner.c"
}

gboolean
games_runner_get_can_quit_safely (GamesRunner* self)
{
#line 7 "../src/core/runner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7 "../src/core/runner.vala"
	return GAMES_RUNNER_GET_INTERFACE (self)->get_can_quit_safely (self);
#line 175 "runner.c"
}

gboolean
games_runner_get_can_resume (GamesRunner* self)
{
#line 8 "../src/core/runner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8 "../src/core/runner.vala"
	return GAMES_RUNNER_GET_INTERFACE (self)->get_can_resume (self);
#line 185 "runner.c"
}

GamesMediaSet*
games_runner_get_media_set (GamesRunner* self)
{
#line 9 "../src/core/runner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9 "../src/core/runner.vala"
	return GAMES_RUNNER_GET_INTERFACE (self)->get_media_set (self);
#line 195 "runner.c"
}

GamesInputMode
games_runner_get_input_mode (GamesRunner* self)
{
#line 10 "../src/core/runner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 10 "../src/core/runner.vala"
	return GAMES_RUNNER_GET_INTERFACE (self)->get_input_mode (self);
#line 205 "runner.c"
}

void
games_runner_set_input_mode (GamesRunner* self,
                             GamesInputMode value)
{
#line 10 "../src/core/runner.vala"
	g_return_if_fail (self != NULL);
#line 10 "../src/core/runner.vala"
	GAMES_RUNNER_GET_INTERFACE (self)->set_input_mode (self, value);
#line 216 "runner.c"
}

static void
games_runner_default_init (GamesRunnerIface * iface,
                           gpointer iface_data)
{
#line 3 "../src/core/runner.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("can-fullscreen", "can-fullscreen", "can-fullscreen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3 "../src/core/runner.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("can-quit-safely", "can-quit-safely", "can-quit-safely", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3 "../src/core/runner.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("can-resume", "can-resume", "can-resume", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3 "../src/core/runner.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("media-set", "media-set", "media-set", GAMES_TYPE_MEDIA_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3 "../src/core/runner.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("input-mode", "input-mode", "input-mode", GAMES_TYPE_INPUT_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3 "../src/core/runner.vala"
	games_runner_signals[GAMES_RUNNER_STOPPED_SIGNAL] = g_signal_new ("stopped", GAMES_TYPE_RUNNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 235 "runner.c"
}

GType
games_runner_get_type (void)
{
	static volatile gsize games_runner_type_id__volatile = 0;
	if (g_once_init_enter (&games_runner_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GamesRunnerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_runner_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType games_runner_type_id;
		games_runner_type_id = g_type_register_static (G_TYPE_INTERFACE, "GamesRunner", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (games_runner_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&games_runner_type_id__volatile, games_runner_type_id);
	}
	return games_runner_type_id__volatile;
}

