/* keyboard-mapping-manager.c generated by valac 0.44.3, the Vala compiler
 * generated from keyboard-mapping-manager.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <glib-object.h>
#include <retro-gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define GAMES_TYPE_KEYBOARD_MAPPING_MANAGER (games_keyboard_mapping_manager_get_type ())
#define GAMES_KEYBOARD_MAPPING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager))
#define GAMES_KEYBOARD_MAPPING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManagerClass))
#define GAMES_IS_KEYBOARD_MAPPING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER))
#define GAMES_IS_KEYBOARD_MAPPING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER))
#define GAMES_KEYBOARD_MAPPING_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManagerClass))

typedef struct _GamesKeyboardMappingManager GamesKeyboardMappingManager;
typedef struct _GamesKeyboardMappingManagerClass GamesKeyboardMappingManagerClass;
typedef struct _GamesKeyboardMappingManagerPrivate GamesKeyboardMappingManagerPrivate;
enum  {
	GAMES_KEYBOARD_MAPPING_MANAGER_0_PROPERTY,
	GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY,
	GAMES_KEYBOARD_MAPPING_MANAGER_NUM_PROPERTIES
};
static GParamSpec* games_keyboard_mapping_manager_properties[GAMES_KEYBOARD_MAPPING_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
enum  {
	GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL,
	GAMES_KEYBOARD_MAPPING_MANAGER_NUM_SIGNALS
};
static guint games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_NUM_SIGNALS] = {0};

struct _GamesKeyboardMappingManager {
	GObject parent_instance;
	GamesKeyboardMappingManagerPrivate * priv;
};

struct _GamesKeyboardMappingManagerClass {
	GObjectClass parent_class;
};

struct _GamesKeyboardMappingManagerPrivate {
	RetroKeyJoypadMapping* _mapping;
	GFile* mapping_file;
	GFileMonitor* mapping_monitor;
};

static gint GamesKeyboardMappingManager_private_offset;
static gpointer games_keyboard_mapping_manager_parent_class = NULL;

GType games_keyboard_mapping_manager_get_type (void) G_GNUC_CONST;
#define GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_FILE_NAME "keyboard-mapping.txt"
#define GAMES_KEYBOARD_MAPPING_MANAGER_GROUP_NAME "KeyboardMapping"
static void games_keyboard_mapping_manager_load_mapping (GamesKeyboardMappingManager* self);
static void games_keyboard_mapping_manager_set_mapping (GamesKeyboardMappingManager* self,
                                                 RetroKeyJoypadMapping* value);
RetroKeyJoypadMapping* games_keyboard_mapping_manager_get_mapping (GamesKeyboardMappingManager* self);
gboolean games_keyboard_mapping_manager_is_default (GamesKeyboardMappingManager* self);
void games_keyboard_mapping_manager_save_mapping (GamesKeyboardMappingManager* self,
                                                  RetroKeyJoypadMapping* mapping);
gchar* games_application_get_config_dir (void);
void games_application_try_make_dir (const gchar* path);
void games_keyboard_mapping_manager_delete_mapping (GamesKeyboardMappingManager* self);
GamesKeyboardMappingManager* games_keyboard_mapping_manager_new (void);
GamesKeyboardMappingManager* games_keyboard_mapping_manager_construct (GType object_type);
static GObject * games_keyboard_mapping_manager_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _games_keyboard_mapping_manager_load_mapping_g_file_monitor_changed (GFileMonitor* _sender,
                                                                          GFile* file,
                                                                          GFile* other_file,
                                                                          GFileMonitorEvent event_type,
                                                                          gpointer self);
static void games_keyboard_mapping_manager_finalize (GObject * obj);
static void _vala_games_keyboard_mapping_manager_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_games_keyboard_mapping_manager_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
games_keyboard_mapping_manager_get_instance_private (GamesKeyboardMappingManager* self)
{
	return G_STRUCT_MEMBER_P (self, GamesKeyboardMappingManager_private_offset);
}

static void
games_keyboard_mapping_manager_load_mapping (GamesKeyboardMappingManager* self)
{
	GFile* _tmp0_;
	RetroKeyJoypadMapping* _tmp3_;
	RetroKeyJoypadMapping* _tmp4_;
	GKeyFile* mapping_key_file = NULL;
	GKeyFile* _tmp5_;
	GEnumClass* enumc = NULL;
	GTypeClass* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 28 "../src/keyboard/keyboard-mapping-manager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp0_ = self->priv->mapping_file;
#line 29 "../src/keyboard/keyboard-mapping-manager.vala"
	if (!g_file_query_exists (_tmp0_, NULL)) {
#line 115 "keyboard-mapping-manager.c"
		RetroKeyJoypadMapping* _tmp1_;
		RetroKeyJoypadMapping* _tmp2_;
#line 30 "../src/keyboard/keyboard-mapping-manager.vala"
		g_debug ("keyboard-mapping-manager.vala:30: User keyboard mapping file doesn't e" \
"xist.");
#line 31 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp1_ = retro_key_joypad_mapping_new_default ();
#line 31 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp2_ = _tmp1_;
#line 31 "../src/keyboard/keyboard-mapping-manager.vala"
		games_keyboard_mapping_manager_set_mapping (self, _tmp2_);
#line 31 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_object_unref0 (_tmp2_);
#line 32 "../src/keyboard/keyboard-mapping-manager.vala"
		g_signal_emit (self, games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL], 0);
#line 34 "../src/keyboard/keyboard-mapping-manager.vala"
		return;
#line 132 "keyboard-mapping-manager.c"
	}
#line 37 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp3_ = retro_key_joypad_mapping_new ();
#line 37 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp4_ = _tmp3_;
#line 37 "../src/keyboard/keyboard-mapping-manager.vala"
	games_keyboard_mapping_manager_set_mapping (self, _tmp4_);
#line 37 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_object_unref0 (_tmp4_);
#line 38 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp5_ = g_key_file_new ();
#line 38 "../src/keyboard/keyboard-mapping-manager.vala"
	mapping_key_file = _tmp5_;
#line 146 "keyboard-mapping-manager.c"
	{
		GKeyFile* _tmp6_;
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 40 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp6_ = mapping_key_file;
#line 40 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp7_ = self->priv->mapping_file;
#line 40 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp8_ = g_file_get_path (_tmp7_);
#line 40 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp9_ = _tmp8_;
#line 40 "../src/keyboard/keyboard-mapping-manager.vala"
		g_key_file_load_from_file (_tmp6_, _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
#line 40 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_free0 (_tmp9_);
#line 40 "../src/keyboard/keyboard-mapping-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "keyboard-mapping-manager.c"
			goto __catch21_g_error;
		}
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 39 "../src/keyboard/keyboard-mapping-manager.vala"
		e = _inner_error0_;
#line 39 "../src/keyboard/keyboard-mapping-manager.vala"
		_inner_error0_ = NULL;
#line 43 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp10_ = e;
#line 43 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp11_ = _tmp10_->message;
#line 43 "../src/keyboard/keyboard-mapping-manager.vala"
		g_critical ("keyboard-mapping-manager.vala:43: %s", _tmp11_);
#line 44 "../src/keyboard/keyboard-mapping-manager.vala"
		g_signal_emit (self, games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL], 0);
#line 46 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_error_free0 (e);
#line 46 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_key_file_unref0 (mapping_key_file);
#line 46 "../src/keyboard/keyboard-mapping-manager.vala"
		return;
#line 194 "keyboard-mapping-manager.c"
	}
	__finally21:
#line 39 "../src/keyboard/keyboard-mapping-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_key_file_unref0 (mapping_key_file);
#line 39 "../src/keyboard/keyboard-mapping-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "../src/keyboard/keyboard-mapping-manager.vala"
		g_clear_error (&_inner_error0_);
#line 39 "../src/keyboard/keyboard-mapping-manager.vala"
		return;
#line 207 "keyboard-mapping-manager.c"
	}
#line 49 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp12_ = g_type_class_ref (retro_joypad_id_get_type ());
#line 49 "../src/keyboard/keyboard-mapping-manager.vala"
	enumc = (GEnumClass*) _tmp12_;
#line 213 "keyboard-mapping-manager.c"
	{
		gint i = 0;
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
		i = 0;
#line 218 "keyboard-mapping-manager.c"
		{
			gboolean _tmp13_ = FALSE;
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
			_tmp13_ = TRUE;
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
			while (TRUE) {
#line 225 "keyboard-mapping-manager.c"
				GEnumClass* _tmp14_;
				GEnumValue* _tmp15_;
				gint _tmp15__length1;
				GEnumValue _tmp16_;
				gchar* button = NULL;
				GEnumClass* _tmp17_;
				GEnumValue* _tmp18_;
				gint _tmp18__length1;
				GEnumValue _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
				if (!_tmp13_) {
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
					i = i + 1;
#line 241 "keyboard-mapping-manager.c"
				}
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp13_ = FALSE;
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp14_ = enumc;
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp15_ = _tmp14_->values;
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp15__length1 = _tmp14_->n_values;
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp16_ = _tmp15_[i];
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
				if (!(_tmp16_.value < ((gint) RETRO_JOYPAD_ID_COUNT))) {
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
					break;
#line 257 "keyboard-mapping-manager.c"
				}
#line 51 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp17_ = enumc;
#line 51 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp18_ = _tmp17_->values;
#line 51 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp18__length1 = _tmp17_->n_values;
#line 51 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp19_ = _tmp18_[i];
#line 51 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp20_ = _tmp19_.value_nick;
#line 51 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp21_ = g_strdup (_tmp20_);
#line 51 "../src/keyboard/keyboard-mapping-manager.vala"
				button = _tmp21_;
#line 273 "keyboard-mapping-manager.c"
				{
					gint key = 0;
					GKeyFile* _tmp22_;
					const gchar* _tmp23_;
					RetroKeyJoypadMapping* _tmp24_;
					GEnumClass* _tmp25_;
					GEnumValue* _tmp26_;
					gint _tmp26__length1;
					GEnumValue _tmp27_;
#line 53 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp22_ = mapping_key_file;
#line 53 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp23_ = button;
#line 53 "../src/keyboard/keyboard-mapping-manager.vala"
					key = g_key_file_get_integer (_tmp22_, GAMES_KEYBOARD_MAPPING_MANAGER_GROUP_NAME, _tmp23_, &_inner_error0_);
#line 53 "../src/keyboard/keyboard-mapping-manager.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "keyboard-mapping-manager.c"
						goto __catch22_g_error;
					}
#line 54 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp24_ = self->priv->_mapping;
#line 54 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp25_ = enumc;
#line 54 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp26_ = _tmp25_->values;
#line 54 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp26__length1 = _tmp25_->n_values;
#line 54 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp27_ = _tmp26_[i];
#line 54 "../src/keyboard/keyboard-mapping-manager.vala"
					retro_key_joypad_mapping_set_button_key (_tmp24_, (RetroJoypadId) _tmp27_.value, (guint16) key);
#line 306 "keyboard-mapping-manager.c"
				}
				goto __finally22;
				__catch22_g_error:
				{
					GError* e = NULL;
					GError* _tmp28_;
					const gchar* _tmp29_;
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					e = _inner_error0_;
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					_inner_error0_ = NULL;
#line 57 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp28_ = e;
#line 57 "../src/keyboard/keyboard-mapping-manager.vala"
					_tmp29_ = _tmp28_->message;
#line 57 "../src/keyboard/keyboard-mapping-manager.vala"
					g_critical ("keyboard-mapping-manager.vala:57: %s", _tmp29_);
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					_g_error_free0 (e);
#line 326 "keyboard-mapping-manager.c"
				}
				__finally22:
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					_g_free0 (button);
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					_g_type_class_unref0 (enumc);
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					_g_key_file_unref0 (mapping_key_file);
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					g_clear_error (&_inner_error0_);
#line 52 "../src/keyboard/keyboard-mapping-manager.vala"
					return;
#line 343 "keyboard-mapping-manager.c"
				}
#line 50 "../src/keyboard/keyboard-mapping-manager.vala"
				_g_free0 (button);
#line 347 "keyboard-mapping-manager.c"
			}
		}
	}
#line 61 "../src/keyboard/keyboard-mapping-manager.vala"
	g_signal_emit (self, games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL], 0);
#line 28 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_type_class_unref0 (enumc);
#line 28 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_key_file_unref0 (mapping_key_file);
#line 357 "keyboard-mapping-manager.c"
}

gboolean
games_keyboard_mapping_manager_is_default (GamesKeyboardMappingManager* self)
{
	gboolean result = FALSE;
	GFile* _tmp0_;
#line 64 "../src/keyboard/keyboard-mapping-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp0_ = self->priv->mapping_file;
#line 65 "../src/keyboard/keyboard-mapping-manager.vala"
	result = !g_file_query_exists (_tmp0_, NULL);
#line 65 "../src/keyboard/keyboard-mapping-manager.vala"
	return result;
#line 373 "keyboard-mapping-manager.c"
}

void
games_keyboard_mapping_manager_save_mapping (GamesKeyboardMappingManager* self,
                                             RetroKeyJoypadMapping* mapping)
{
	gchar* config_dir = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GKeyFile* mapping_key_file = NULL;
	GKeyFile* _tmp2_;
	GEnumClass* enumc = NULL;
	GTypeClass* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 68 "../src/keyboard/keyboard-mapping-manager.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/keyboard/keyboard-mapping-manager.vala"
	g_return_if_fail (mapping != NULL);
#line 69 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp0_ = games_application_get_config_dir ();
#line 69 "../src/keyboard/keyboard-mapping-manager.vala"
	config_dir = _tmp0_;
#line 70 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp1_ = config_dir;
#line 70 "../src/keyboard/keyboard-mapping-manager.vala"
	games_application_try_make_dir (_tmp1_);
#line 72 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp2_ = g_key_file_new ();
#line 72 "../src/keyboard/keyboard-mapping-manager.vala"
	mapping_key_file = _tmp2_;
#line 73 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp3_ = g_type_class_ref (retro_joypad_id_get_type ());
#line 73 "../src/keyboard/keyboard-mapping-manager.vala"
	enumc = (GEnumClass*) _tmp3_;
#line 408 "keyboard-mapping-manager.c"
	{
		gint i = 0;
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
		i = 0;
#line 413 "keyboard-mapping-manager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
			_tmp4_ = TRUE;
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
			while (TRUE) {
#line 420 "keyboard-mapping-manager.c"
				GEnumClass* _tmp5_;
				GEnumValue* _tmp6_;
				gint _tmp6__length1;
				GEnumValue _tmp7_;
				gchar* button = NULL;
				GEnumClass* _tmp8_;
				GEnumValue* _tmp9_;
				gint _tmp9__length1;
				GEnumValue _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				guint16 key = 0U;
				GEnumClass* _tmp13_;
				GEnumValue* _tmp14_;
				gint _tmp14__length1;
				GEnumValue _tmp15_;
				GKeyFile* _tmp16_;
				const gchar* _tmp17_;
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
				if (!_tmp4_) {
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
					i = i + 1;
#line 443 "keyboard-mapping-manager.c"
				}
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp4_ = FALSE;
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp5_ = enumc;
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp6_ = _tmp5_->values;
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp6__length1 = _tmp5_->n_values;
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp7_ = _tmp6_[i];
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
				if (!(_tmp7_.value < ((gint) RETRO_JOYPAD_ID_COUNT))) {
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
					break;
#line 459 "keyboard-mapping-manager.c"
				}
#line 75 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp8_ = enumc;
#line 75 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp9_ = _tmp8_->values;
#line 75 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp9__length1 = _tmp8_->n_values;
#line 75 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp10_ = _tmp9_[i];
#line 75 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp11_ = _tmp10_.value_nick;
#line 75 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp12_ = g_strdup (_tmp11_);
#line 75 "../src/keyboard/keyboard-mapping-manager.vala"
				button = _tmp12_;
#line 76 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp13_ = enumc;
#line 76 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp14_ = _tmp13_->values;
#line 76 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp14__length1 = _tmp13_->n_values;
#line 76 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp15_ = _tmp14_[i];
#line 76 "../src/keyboard/keyboard-mapping-manager.vala"
				key = retro_key_joypad_mapping_get_button_key (mapping, (RetroJoypadId) _tmp15_.value);
#line 77 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp16_ = mapping_key_file;
#line 77 "../src/keyboard/keyboard-mapping-manager.vala"
				_tmp17_ = button;
#line 77 "../src/keyboard/keyboard-mapping-manager.vala"
				g_key_file_set_integer (_tmp16_, GAMES_KEYBOARD_MAPPING_MANAGER_GROUP_NAME, _tmp17_, (gint) key);
#line 74 "../src/keyboard/keyboard-mapping-manager.vala"
				_g_free0 (button);
#line 493 "keyboard-mapping-manager.c"
			}
		}
	}
	{
		GKeyFile* _tmp18_;
		GFile* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 81 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp18_ = mapping_key_file;
#line 81 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp19_ = self->priv->mapping_file;
#line 81 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp20_ = g_file_get_path (_tmp19_);
#line 81 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp21_ = _tmp20_;
#line 81 "../src/keyboard/keyboard-mapping-manager.vala"
		g_key_file_save_to_file (_tmp18_, _tmp21_, &_inner_error0_);
#line 81 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_free0 (_tmp21_);
#line 81 "../src/keyboard/keyboard-mapping-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 516 "keyboard-mapping-manager.c"
			goto __catch23_g_error;
		}
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		GError* _tmp22_;
		const gchar* _tmp23_;
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		e = _inner_error0_;
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		_inner_error0_ = NULL;
#line 84 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp22_ = e;
#line 84 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp23_ = _tmp22_->message;
#line 84 "../src/keyboard/keyboard-mapping-manager.vala"
		g_critical ("keyboard-mapping-manager.vala:84: %s", _tmp23_);
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_error_free0 (e);
#line 538 "keyboard-mapping-manager.c"
	}
	__finally23:
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_type_class_unref0 (enumc);
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_key_file_unref0 (mapping_key_file);
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_free0 (config_dir);
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		g_clear_error (&_inner_error0_);
#line 80 "../src/keyboard/keyboard-mapping-manager.vala"
		return;
#line 555 "keyboard-mapping-manager.c"
	}
#line 68 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_type_class_unref0 (enumc);
#line 68 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_key_file_unref0 (mapping_key_file);
#line 68 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_free0 (config_dir);
#line 563 "keyboard-mapping-manager.c"
}

void
games_keyboard_mapping_manager_delete_mapping (GamesKeyboardMappingManager* self)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 88 "../src/keyboard/keyboard-mapping-manager.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp0_ = self->priv->mapping_file;
#line 89 "../src/keyboard/keyboard-mapping-manager.vala"
	if (!g_file_query_exists (_tmp0_, NULL)) {
#line 90 "../src/keyboard/keyboard-mapping-manager.vala"
		return;
#line 579 "keyboard-mapping-manager.c"
	}
	{
		GFile* _tmp1_;
#line 93 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp1_ = self->priv->mapping_file;
#line 93 "../src/keyboard/keyboard-mapping-manager.vala"
		g_file_delete (_tmp1_, NULL, &_inner_error0_);
#line 93 "../src/keyboard/keyboard-mapping-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 589 "keyboard-mapping-manager.c"
			goto __catch24_g_error;
		}
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 92 "../src/keyboard/keyboard-mapping-manager.vala"
		e = _inner_error0_;
#line 92 "../src/keyboard/keyboard-mapping-manager.vala"
		_inner_error0_ = NULL;
#line 96 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp2_ = e;
#line 96 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp3_ = _tmp2_->message;
#line 96 "../src/keyboard/keyboard-mapping-manager.vala"
		g_critical ("keyboard-mapping-manager.vala:96: %s", _tmp3_);
#line 92 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_error_free0 (e);
#line 611 "keyboard-mapping-manager.c"
	}
	__finally24:
#line 92 "../src/keyboard/keyboard-mapping-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "../src/keyboard/keyboard-mapping-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../src/keyboard/keyboard-mapping-manager.vala"
		g_clear_error (&_inner_error0_);
#line 92 "../src/keyboard/keyboard-mapping-manager.vala"
		return;
#line 622 "keyboard-mapping-manager.c"
	}
}

GamesKeyboardMappingManager*
games_keyboard_mapping_manager_construct (GType object_type)
{
	GamesKeyboardMappingManager * self = NULL;
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	self = (GamesKeyboardMappingManager*) g_object_new (object_type, NULL);
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	return self;
#line 634 "keyboard-mapping-manager.c"
}

GamesKeyboardMappingManager*
games_keyboard_mapping_manager_new (void)
{
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	return games_keyboard_mapping_manager_construct (GAMES_TYPE_KEYBOARD_MAPPING_MANAGER);
#line 642 "keyboard-mapping-manager.c"
}

RetroKeyJoypadMapping*
games_keyboard_mapping_manager_get_mapping (GamesKeyboardMappingManager* self)
{
	RetroKeyJoypadMapping* result;
	RetroKeyJoypadMapping* _tmp0_;
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp0_ = self->priv->_mapping;
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
	result = _tmp0_;
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
	return result;
#line 658 "keyboard-mapping-manager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 666 "keyboard-mapping-manager.c"
}

static void
games_keyboard_mapping_manager_set_mapping (GamesKeyboardMappingManager* self,
                                            RetroKeyJoypadMapping* value)
{
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
	g_return_if_fail (self != NULL);
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
	if (games_keyboard_mapping_manager_get_mapping (self) != value) {
#line 677 "keyboard-mapping-manager.c"
		RetroKeyJoypadMapping* _tmp0_;
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_object_unref0 (self->priv->_mapping);
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
		self->priv->_mapping = _tmp0_;
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
		g_object_notify_by_pspec ((GObject *) self, games_keyboard_mapping_manager_properties[GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY]);
#line 687 "keyboard-mapping-manager.c"
	}
}

static void
_games_keyboard_mapping_manager_load_mapping_g_file_monitor_changed (GFileMonitor* _sender,
                                                                     GFile* file,
                                                                     GFile* other_file,
                                                                     GFileMonitorEvent event_type,
                                                                     gpointer self)
{
#line 19 "../src/keyboard/keyboard-mapping-manager.vala"
	games_keyboard_mapping_manager_load_mapping ((GamesKeyboardMappingManager*) self);
#line 700 "keyboard-mapping-manager.c"
}

static GObject *
games_keyboard_mapping_manager_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GamesKeyboardMappingManager * self;
	gchar* config_dir = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 13 "../src/keyboard/keyboard-mapping-manager.vala"
	parent_class = G_OBJECT_CLASS (games_keyboard_mapping_manager_parent_class);
#line 13 "../src/keyboard/keyboard-mapping-manager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 13 "../src/keyboard/keyboard-mapping-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager);
#line 14 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp0_ = games_application_get_config_dir ();
#line 14 "../src/keyboard/keyboard-mapping-manager.vala"
	config_dir = _tmp0_;
#line 15 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp1_ = config_dir;
#line 15 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp2_ = g_build_filename (_tmp1_, GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_FILE_NAME, NULL);
#line 15 "../src/keyboard/keyboard-mapping-manager.vala"
	path = _tmp2_;
#line 16 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp3_ = path;
#line 16 "../src/keyboard/keyboard-mapping-manager.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 16 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_object_unref0 (self->priv->mapping_file);
#line 16 "../src/keyboard/keyboard-mapping-manager.vala"
	self->priv->mapping_file = _tmp4_;
#line 743 "keyboard-mapping-manager.c"
	{
		GFileMonitor* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFileMonitor* _tmp7_;
		GFileMonitor* _tmp8_;
		GFileMonitor* _tmp9_;
#line 18 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp6_ = self->priv->mapping_file;
#line 18 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp7_ = g_file_monitor (_tmp6_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 18 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp5_ = _tmp7_;
#line 18 "../src/keyboard/keyboard-mapping-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 758 "keyboard-mapping-manager.c"
			goto __catch25_g_error;
		}
#line 18 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp8_ = _tmp5_;
#line 18 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp5_ = NULL;
#line 18 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_object_unref0 (self->priv->mapping_monitor);
#line 18 "../src/keyboard/keyboard-mapping-manager.vala"
		self->priv->mapping_monitor = _tmp8_;
#line 19 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp9_ = self->priv->mapping_monitor;
#line 19 "../src/keyboard/keyboard-mapping-manager.vala"
		g_signal_connect_object (_tmp9_, "changed", (GCallback) _games_keyboard_mapping_manager_load_mapping_g_file_monitor_changed, self, 0);
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_object_unref0 (_tmp5_);
#line 775 "keyboard-mapping-manager.c"
	}
	goto __finally25;
	__catch25_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
		e = _inner_error0_;
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
		_inner_error0_ = NULL;
#line 22 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp10_ = e;
#line 22 "../src/keyboard/keyboard-mapping-manager.vala"
		_tmp11_ = _tmp10_->message;
#line 22 "../src/keyboard/keyboard-mapping-manager.vala"
		g_critical ("keyboard-mapping-manager.vala:22: %s", _tmp11_);
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_error_free0 (e);
#line 795 "keyboard-mapping-manager.c"
	}
	__finally25:
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_free0 (path);
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
		_g_free0 (config_dir);
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 17 "../src/keyboard/keyboard-mapping-manager.vala"
		g_clear_error (&_inner_error0_);
#line 808 "keyboard-mapping-manager.c"
	}
#line 25 "../src/keyboard/keyboard-mapping-manager.vala"
	games_keyboard_mapping_manager_load_mapping (self);
#line 13 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_free0 (path);
#line 13 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_free0 (config_dir);
#line 13 "../src/keyboard/keyboard-mapping-manager.vala"
	return obj;
#line 818 "keyboard-mapping-manager.c"
}

static void
games_keyboard_mapping_manager_class_init (GamesKeyboardMappingManagerClass * klass,
                                           gpointer klass_data)
{
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	games_keyboard_mapping_manager_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	g_type_class_adjust_private_offset (klass, &GamesKeyboardMappingManager_private_offset);
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_keyboard_mapping_manager_get_property;
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_games_keyboard_mapping_manager_set_property;
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	G_OBJECT_CLASS (klass)->constructor = games_keyboard_mapping_manager_constructor;
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = games_keyboard_mapping_manager_finalize;
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY, games_keyboard_mapping_manager_properties[GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY] = g_param_spec_object ("mapping", "mapping", "mapping", retro_key_joypad_mapping_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL] = g_signal_new ("changed", GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 841 "keyboard-mapping-manager.c"
}

static void
games_keyboard_mapping_manager_instance_init (GamesKeyboardMappingManager * self,
                                              gpointer klass)
{
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	self->priv = games_keyboard_mapping_manager_get_instance_private (self);
#line 850 "keyboard-mapping-manager.c"
}

static void
games_keyboard_mapping_manager_finalize (GObject * obj)
{
	GamesKeyboardMappingManager * self;
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager);
#line 8 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_object_unref0 (self->priv->_mapping);
#line 10 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_object_unref0 (self->priv->mapping_file);
#line 11 "../src/keyboard/keyboard-mapping-manager.vala"
	_g_object_unref0 (self->priv->mapping_monitor);
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	G_OBJECT_CLASS (games_keyboard_mapping_manager_parent_class)->finalize (obj);
#line 867 "keyboard-mapping-manager.c"
}

GType
games_keyboard_mapping_manager_get_type (void)
{
	static volatile gsize games_keyboard_mapping_manager_type_id__volatile = 0;
	if (g_once_init_enter (&games_keyboard_mapping_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GamesKeyboardMappingManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_keyboard_mapping_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesKeyboardMappingManager), 0, (GInstanceInitFunc) games_keyboard_mapping_manager_instance_init, NULL };
		GType games_keyboard_mapping_manager_type_id;
		games_keyboard_mapping_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GamesKeyboardMappingManager", &g_define_type_info, 0);
		GamesKeyboardMappingManager_private_offset = g_type_add_instance_private (games_keyboard_mapping_manager_type_id, sizeof (GamesKeyboardMappingManagerPrivate));
		g_once_init_leave (&games_keyboard_mapping_manager_type_id__volatile, games_keyboard_mapping_manager_type_id);
	}
	return games_keyboard_mapping_manager_type_id__volatile;
}

static void
_vala_games_keyboard_mapping_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	GamesKeyboardMappingManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager);
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	switch (property_id) {
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		case GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY:
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		g_value_set_object (value, games_keyboard_mapping_manager_get_mapping (self));
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		break;
#line 900 "keyboard-mapping-manager.c"
		default:
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		break;
#line 906 "keyboard-mapping-manager.c"
	}
}

static void
_vala_games_keyboard_mapping_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	GamesKeyboardMappingManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager);
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
	switch (property_id) {
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		case GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY:
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		games_keyboard_mapping_manager_set_mapping (self, g_value_get_object (value));
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		break;
#line 926 "keyboard-mapping-manager.c"
		default:
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/keyboard/keyboard-mapping-manager.vala"
		break;
#line 932 "keyboard-mapping-manager.c"
	}
}

