/* retro-gamepad.c generated by valac 0.44.3, the Vala compiler
 * generated from retro-gamepad.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <glib-object.h>
#include <retro-gtk.h>
#include <libmanette.h>
#include <glib.h>
#include "linux/input-event-codes.h"
#include <float.h>
#include <math.h>

#define GAMES_TYPE_RETRO_GAMEPAD (games_retro_gamepad_get_type ())
#define GAMES_RETRO_GAMEPAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_RETRO_GAMEPAD, GamesRetroGamepad))
#define GAMES_RETRO_GAMEPAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_RETRO_GAMEPAD, GamesRetroGamepadClass))
#define GAMES_IS_RETRO_GAMEPAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_RETRO_GAMEPAD))
#define GAMES_IS_RETRO_GAMEPAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_RETRO_GAMEPAD))
#define GAMES_RETRO_GAMEPAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_RETRO_GAMEPAD, GamesRetroGamepadClass))

typedef struct _GamesRetroGamepad GamesRetroGamepad;
typedef struct _GamesRetroGamepadClass GamesRetroGamepadClass;
typedef struct _GamesRetroGamepadPrivate GamesRetroGamepadPrivate;
enum  {
	GAMES_RETRO_GAMEPAD_0_PROPERTY,
	GAMES_RETRO_GAMEPAD_DEVICE_PROPERTY,
	GAMES_RETRO_GAMEPAD_PRESENT_ANALOG_STICKS_PROPERTY,
	GAMES_RETRO_GAMEPAD_NUM_PROPERTIES
};
static GParamSpec* games_retro_gamepad_properties[GAMES_RETRO_GAMEPAD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GamesRetroGamepad {
	GObject parent_instance;
	GamesRetroGamepadPrivate * priv;
};

struct _GamesRetroGamepadClass {
	GObjectClass parent_class;
};

struct _GamesRetroGamepadPrivate {
	ManetteDevice* _device;
	gboolean _present_analog_sticks;
	gboolean* buttons;
	gint buttons_length1;
	gint _buttons_size_;
	gint16* axes;
	gint axes_length1;
	gint _axes_size_;
	guint16 rumble_effect[2];
};

static gint GamesRetroGamepad_private_offset;
static gpointer games_retro_gamepad_parent_class = NULL;
static RetroControllerInterface * games_retro_gamepad_retro_controller_parent_iface = NULL;

GType games_retro_gamepad_get_type (void) G_GNUC_CONST;
GamesRetroGamepad* games_retro_gamepad_new (ManetteDevice* device,
                                            gboolean present_analog_sticks);
GamesRetroGamepad* games_retro_gamepad_construct (GType object_type,
                                                  ManetteDevice* device,
                                                  gboolean present_analog_sticks);
static void games_retro_gamepad_real_poll (RetroController* base);
static gint16 games_retro_gamepad_real_get_input_state (RetroController* base,
                                                 RetroInput* input);
static gboolean games_retro_gamepad_get_button_pressed (GamesRetroGamepad* self,
                                                 RetroJoypadId button);
static gint16 games_retro_gamepad_get_analog_value (GamesRetroGamepad* self,
                                             RetroAnalogIndex index,
                                             RetroAnalogId id);
static RetroControllerType games_retro_gamepad_real_get_controller_type (RetroController* base);
gboolean games_retro_gamepad_get_present_analog_sticks (GamesRetroGamepad* self);
static guint64 games_retro_gamepad_real_get_capabilities (RetroController* base);
static gboolean games_retro_gamepad_real_set_rumble_state (RetroController* base,
                                                    RetroRumbleEffect effect,
                                                    guint16 strength);
ManetteDevice* games_retro_gamepad_get_device (GamesRetroGamepad* self);
static void games_retro_gamepad_on_button_press_event (GamesRetroGamepad* self,
                                                ManetteEvent* event);
static void games_retro_gamepad_on_button_release_event (GamesRetroGamepad* self,
                                                  ManetteEvent* event);
static void games_retro_gamepad_on_absolute_axis_event (GamesRetroGamepad* self,
                                                 ManetteEvent* event);
static void games_retro_gamepad_set_device (GamesRetroGamepad* self,
                                     ManetteDevice* value);
static void games_retro_gamepad_set_present_analog_sticks (GamesRetroGamepad* self,
                                                    gboolean value);
static GObject * games_retro_gamepad_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _games_retro_gamepad_on_button_press_event_manette_device_button_press_event (ManetteDevice* _sender,
                                                                                   ManetteEvent* event,
                                                                                   gpointer self);
static void _games_retro_gamepad_on_button_release_event_manette_device_button_release_event (ManetteDevice* _sender,
                                                                                       ManetteEvent* event,
                                                                                       gpointer self);
static void _games_retro_gamepad_on_absolute_axis_event_manette_device_absolute_axis_event (ManetteDevice* _sender,
                                                                                     ManetteEvent* event,
                                                                                     gpointer self);
static void games_retro_gamepad_finalize (GObject * obj);
static void _vala_games_retro_gamepad_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_games_retro_gamepad_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
games_retro_gamepad_get_instance_private (GamesRetroGamepad* self)
{
	return G_STRUCT_MEMBER_P (self, GamesRetroGamepad_private_offset);
}

GamesRetroGamepad*
games_retro_gamepad_construct (GType object_type,
                               ManetteDevice* device,
                               gboolean present_analog_sticks)
{
	GamesRetroGamepad * self = NULL;
#line 11 "../src/retro/retro-gamepad.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 12 "../src/retro/retro-gamepad.vala"
	self = (GamesRetroGamepad*) g_object_new (object_type, "device", device, "present-analog-sticks", present_analog_sticks, NULL);
#line 11 "../src/retro/retro-gamepad.vala"
	return self;
#line 130 "retro-gamepad.c"
}

GamesRetroGamepad*
games_retro_gamepad_new (ManetteDevice* device,
                         gboolean present_analog_sticks)
{
#line 11 "../src/retro/retro-gamepad.vala"
	return games_retro_gamepad_construct (GAMES_TYPE_RETRO_GAMEPAD, device, present_analog_sticks);
#line 139 "retro-gamepad.c"
}

static void
games_retro_gamepad_real_poll (RetroController* base)
{
	GamesRetroGamepad * self;
#line 24 "../src/retro/retro-gamepad.vala"
	self = (GamesRetroGamepad*) base;
#line 148 "retro-gamepad.c"
}

static gint16
games_retro_gamepad_real_get_input_state (RetroController* base,
                                          RetroInput* input)
{
	GamesRetroGamepad * self;
	gint16 result = 0;
#line 26 "../src/retro/retro-gamepad.vala"
	self = (GamesRetroGamepad*) base;
#line 26 "../src/retro/retro-gamepad.vala"
	g_return_val_if_fail (input != NULL, 0);
#line 27 "../src/retro/retro-gamepad.vala"
	switch (retro_input_get_controller_type (input)) {
#line 27 "../src/retro/retro-gamepad.vala"
		case RETRO_CONTROLLER_TYPE_JOYPAD:
#line 165 "retro-gamepad.c"
		{
			RetroJoypadId id = 0;
			RetroJoypadId _tmp0_ = 0;
			gboolean _tmp1_;
			gint16 _tmp2_ = 0;
			RetroJoypadId _tmp3_;
#line 30 "../src/retro/retro-gamepad.vala"
			_tmp1_ = retro_input_get_joypad (input, &_tmp0_);
#line 30 "../src/retro/retro-gamepad.vala"
			id = _tmp0_;
#line 30 "../src/retro/retro-gamepad.vala"
			if (!_tmp1_) {
#line 31 "../src/retro/retro-gamepad.vala"
				result = (gint16) 0;
#line 31 "../src/retro/retro-gamepad.vala"
				return result;
#line 182 "retro-gamepad.c"
			}
#line 33 "../src/retro/retro-gamepad.vala"
			_tmp3_ = id;
#line 33 "../src/retro/retro-gamepad.vala"
			if (games_retro_gamepad_get_button_pressed (self, _tmp3_)) {
#line 33 "../src/retro/retro-gamepad.vala"
				_tmp2_ = G_MAXINT16;
#line 190 "retro-gamepad.c"
			} else {
#line 33 "../src/retro/retro-gamepad.vala"
				_tmp2_ = (gint16) 0;
#line 194 "retro-gamepad.c"
			}
#line 33 "../src/retro/retro-gamepad.vala"
			result = _tmp2_;
#line 33 "../src/retro/retro-gamepad.vala"
			return result;
#line 200 "retro-gamepad.c"
		}
#line 27 "../src/retro/retro-gamepad.vala"
		case RETRO_CONTROLLER_TYPE_ANALOG:
#line 204 "retro-gamepad.c"
		{
			RetroAnalogId id = 0;
			RetroAnalogIndex index = 0;
			RetroAnalogId _tmp4_ = 0;
			RetroAnalogIndex _tmp5_ = 0;
			gboolean _tmp6_;
			RetroAnalogIndex _tmp7_;
			RetroAnalogId _tmp8_;
#line 37 "../src/retro/retro-gamepad.vala"
			_tmp6_ = retro_input_get_analog (input, &_tmp4_, &_tmp5_);
#line 37 "../src/retro/retro-gamepad.vala"
			id = _tmp4_;
#line 37 "../src/retro/retro-gamepad.vala"
			index = _tmp5_;
#line 37 "../src/retro/retro-gamepad.vala"
			if (!_tmp6_) {
#line 38 "../src/retro/retro-gamepad.vala"
				result = (gint16) 0;
#line 38 "../src/retro/retro-gamepad.vala"
				return result;
#line 225 "retro-gamepad.c"
			}
#line 40 "../src/retro/retro-gamepad.vala"
			_tmp7_ = index;
#line 40 "../src/retro/retro-gamepad.vala"
			_tmp8_ = id;
#line 40 "../src/retro/retro-gamepad.vala"
			result = games_retro_gamepad_get_analog_value (self, _tmp7_, _tmp8_);
#line 40 "../src/retro/retro-gamepad.vala"
			return result;
#line 235 "retro-gamepad.c"
		}
		default:
		{
#line 42 "../src/retro/retro-gamepad.vala"
			result = (gint16) 0;
#line 42 "../src/retro/retro-gamepad.vala"
			return result;
#line 243 "retro-gamepad.c"
		}
	}
}

static RetroControllerType
games_retro_gamepad_real_get_controller_type (RetroController* base)
{
	GamesRetroGamepad * self;
	RetroControllerType result = 0;
	gboolean _tmp0_;
#line 46 "../src/retro/retro-gamepad.vala"
	self = (GamesRetroGamepad*) base;
#line 47 "../src/retro/retro-gamepad.vala"
	_tmp0_ = self->priv->_present_analog_sticks;
#line 47 "../src/retro/retro-gamepad.vala"
	if (_tmp0_) {
#line 48 "../src/retro/retro-gamepad.vala"
		result = RETRO_CONTROLLER_TYPE_ANALOG;
#line 48 "../src/retro/retro-gamepad.vala"
		return result;
#line 264 "retro-gamepad.c"
	}
#line 50 "../src/retro/retro-gamepad.vala"
	result = RETRO_CONTROLLER_TYPE_JOYPAD;
#line 50 "../src/retro/retro-gamepad.vala"
	return result;
#line 270 "retro-gamepad.c"
}

static guint64
games_retro_gamepad_real_get_capabilities (RetroController* base)
{
	GamesRetroGamepad * self;
	guint64 result = 0ULL;
#line 53 "../src/retro/retro-gamepad.vala"
	self = (GamesRetroGamepad*) base;
#line 54 "../src/retro/retro-gamepad.vala"
	result = (guint64) ((1 << RETRO_CONTROLLER_TYPE_JOYPAD) | (1 << RETRO_CONTROLLER_TYPE_ANALOG));
#line 54 "../src/retro/retro-gamepad.vala"
	return result;
#line 284 "retro-gamepad.c"
}

static gboolean
games_retro_gamepad_real_set_rumble_state (RetroController* base,
                                           RetroRumbleEffect effect,
                                           guint16 strength)
{
	GamesRetroGamepad * self;
	gboolean result = FALSE;
	ManetteDevice* _tmp0_;
	ManetteDevice* _tmp1_;
	guint16 _tmp2_;
	guint16 _tmp3_;
#line 57 "../src/retro/retro-gamepad.vala"
	self = (GamesRetroGamepad*) base;
#line 58 "../src/retro/retro-gamepad.vala"
	self->priv->rumble_effect[effect] = strength;
#line 60 "../src/retro/retro-gamepad.vala"
	_tmp0_ = self->priv->_device;
#line 60 "../src/retro/retro-gamepad.vala"
	if (!manette_device_has_rumble (_tmp0_)) {
#line 61 "../src/retro/retro-gamepad.vala"
		result = FALSE;
#line 61 "../src/retro/retro-gamepad.vala"
		return result;
#line 310 "retro-gamepad.c"
	}
#line 63 "../src/retro/retro-gamepad.vala"
	_tmp1_ = self->priv->_device;
#line 63 "../src/retro/retro-gamepad.vala"
	_tmp2_ = self->priv->rumble_effect[RETRO_RUMBLE_EFFECT_STRONG];
#line 63 "../src/retro/retro-gamepad.vala"
	_tmp3_ = self->priv->rumble_effect[RETRO_RUMBLE_EFFECT_WEAK];
#line 63 "../src/retro/retro-gamepad.vala"
	manette_device_rumble (_tmp1_, _tmp2_, _tmp3_, G_MAXUINT16);
#line 67 "../src/retro/retro-gamepad.vala"
	result = TRUE;
#line 67 "../src/retro/retro-gamepad.vala"
	return result;
#line 324 "retro-gamepad.c"
}

static gboolean
games_retro_gamepad_get_button_pressed (GamesRetroGamepad* self,
                                        RetroJoypadId button)
{
	gboolean result = FALSE;
	guint16 button_code = 0U;
	gboolean _tmp0_ = FALSE;
#line 70 "../src/retro/retro-gamepad.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "../src/retro/retro-gamepad.vala"
	button_code = retro_joypad_id_to_button_code (button);
#line 73 "../src/retro/retro-gamepad.vala"
	if (button_code != EV_MAX) {
#line 340 "retro-gamepad.c"
		gboolean* _tmp1_;
		gint _tmp1__length1;
		gboolean _tmp2_;
#line 73 "../src/retro/retro-gamepad.vala"
		_tmp1_ = self->priv->buttons;
#line 73 "../src/retro/retro-gamepad.vala"
		_tmp1__length1 = self->priv->buttons_length1;
#line 73 "../src/retro/retro-gamepad.vala"
		_tmp2_ = _tmp1_[button_code];
#line 73 "../src/retro/retro-gamepad.vala"
		_tmp0_ = _tmp2_;
#line 352 "retro-gamepad.c"
	} else {
#line 73 "../src/retro/retro-gamepad.vala"
		_tmp0_ = FALSE;
#line 356 "retro-gamepad.c"
	}
#line 73 "../src/retro/retro-gamepad.vala"
	result = _tmp0_;
#line 73 "../src/retro/retro-gamepad.vala"
	return result;
#line 362 "retro-gamepad.c"
}

static gint16
games_retro_gamepad_get_analog_value (GamesRetroGamepad* self,
                                      RetroAnalogIndex index,
                                      RetroAnalogId id)
{
	gint16 result = 0;
#line 76 "../src/retro/retro-gamepad.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../src/retro/retro-gamepad.vala"
	switch (index) {
#line 77 "../src/retro/retro-gamepad.vala"
		case RETRO_ANALOG_INDEX_LEFT:
#line 377 "retro-gamepad.c"
		{
#line 79 "../src/retro/retro-gamepad.vala"
			switch (id) {
#line 79 "../src/retro/retro-gamepad.vala"
				case RETRO_ANALOG_ID_X:
#line 383 "retro-gamepad.c"
				{
					gint16* _tmp0_;
					gint _tmp0__length1;
					gint16 _tmp1_;
#line 81 "../src/retro/retro-gamepad.vala"
					_tmp0_ = self->priv->axes;
#line 81 "../src/retro/retro-gamepad.vala"
					_tmp0__length1 = self->priv->axes_length1;
#line 81 "../src/retro/retro-gamepad.vala"
					_tmp1_ = _tmp0_[ABS_X];
#line 81 "../src/retro/retro-gamepad.vala"
					result = _tmp1_;
#line 81 "../src/retro/retro-gamepad.vala"
					return result;
#line 398 "retro-gamepad.c"
				}
#line 79 "../src/retro/retro-gamepad.vala"
				case RETRO_ANALOG_ID_Y:
#line 402 "retro-gamepad.c"
				{
					gint16* _tmp2_;
					gint _tmp2__length1;
					gint16 _tmp3_;
#line 83 "../src/retro/retro-gamepad.vala"
					_tmp2_ = self->priv->axes;
#line 83 "../src/retro/retro-gamepad.vala"
					_tmp2__length1 = self->priv->axes_length1;
#line 83 "../src/retro/retro-gamepad.vala"
					_tmp3_ = _tmp2_[ABS_Y];
#line 83 "../src/retro/retro-gamepad.vala"
					result = _tmp3_;
#line 83 "../src/retro/retro-gamepad.vala"
					return result;
#line 417 "retro-gamepad.c"
				}
				default:
				{
#line 85 "../src/retro/retro-gamepad.vala"
					result = (gint16) 0;
#line 85 "../src/retro/retro-gamepad.vala"
					return result;
#line 425 "retro-gamepad.c"
				}
			}
		}
#line 77 "../src/retro/retro-gamepad.vala"
		case RETRO_ANALOG_INDEX_RIGHT:
#line 431 "retro-gamepad.c"
		{
#line 88 "../src/retro/retro-gamepad.vala"
			switch (id) {
#line 88 "../src/retro/retro-gamepad.vala"
				case RETRO_ANALOG_ID_X:
#line 437 "retro-gamepad.c"
				{
					gint16* _tmp4_;
					gint _tmp4__length1;
					gint16 _tmp5_;
#line 90 "../src/retro/retro-gamepad.vala"
					_tmp4_ = self->priv->axes;
#line 90 "../src/retro/retro-gamepad.vala"
					_tmp4__length1 = self->priv->axes_length1;
#line 90 "../src/retro/retro-gamepad.vala"
					_tmp5_ = _tmp4_[ABS_RX];
#line 90 "../src/retro/retro-gamepad.vala"
					result = _tmp5_;
#line 90 "../src/retro/retro-gamepad.vala"
					return result;
#line 452 "retro-gamepad.c"
				}
#line 88 "../src/retro/retro-gamepad.vala"
				case RETRO_ANALOG_ID_Y:
#line 456 "retro-gamepad.c"
				{
					gint16* _tmp6_;
					gint _tmp6__length1;
					gint16 _tmp7_;
#line 92 "../src/retro/retro-gamepad.vala"
					_tmp6_ = self->priv->axes;
#line 92 "../src/retro/retro-gamepad.vala"
					_tmp6__length1 = self->priv->axes_length1;
#line 92 "../src/retro/retro-gamepad.vala"
					_tmp7_ = _tmp6_[ABS_RY];
#line 92 "../src/retro/retro-gamepad.vala"
					result = _tmp7_;
#line 92 "../src/retro/retro-gamepad.vala"
					return result;
#line 471 "retro-gamepad.c"
				}
				default:
				{
#line 94 "../src/retro/retro-gamepad.vala"
					result = (gint16) 0;
#line 94 "../src/retro/retro-gamepad.vala"
					return result;
#line 479 "retro-gamepad.c"
				}
			}
		}
		default:
		{
#line 97 "../src/retro/retro-gamepad.vala"
			result = (gint16) 0;
#line 97 "../src/retro/retro-gamepad.vala"
			return result;
#line 489 "retro-gamepad.c"
		}
	}
}

static void
games_retro_gamepad_on_button_press_event (GamesRetroGamepad* self,
                                           ManetteEvent* event)
{
	guint16 button = 0U;
	guint16 _tmp0_ = 0U;
	gboolean _tmp1_;
#line 101 "../src/retro/retro-gamepad.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/retro/retro-gamepad.vala"
	g_return_if_fail (event != NULL);
#line 104 "../src/retro/retro-gamepad.vala"
	_tmp1_ = manette_event_get_button (event, &_tmp0_);
#line 104 "../src/retro/retro-gamepad.vala"
	button = _tmp0_;
#line 104 "../src/retro/retro-gamepad.vala"
	if (_tmp1_) {
#line 511 "retro-gamepad.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
#line 105 "../src/retro/retro-gamepad.vala"
		_tmp2_ = self->priv->buttons;
#line 105 "../src/retro/retro-gamepad.vala"
		_tmp2__length1 = self->priv->buttons_length1;
#line 105 "../src/retro/retro-gamepad.vala"
		_tmp2_[button] = TRUE;
#line 520 "retro-gamepad.c"
	}
}

static void
games_retro_gamepad_on_button_release_event (GamesRetroGamepad* self,
                                             ManetteEvent* event)
{
	guint16 button = 0U;
	guint16 _tmp0_ = 0U;
	gboolean _tmp1_;
#line 108 "../src/retro/retro-gamepad.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/retro/retro-gamepad.vala"
	g_return_if_fail (event != NULL);
#line 111 "../src/retro/retro-gamepad.vala"
	_tmp1_ = manette_event_get_button (event, &_tmp0_);
#line 111 "../src/retro/retro-gamepad.vala"
	button = _tmp0_;
#line 111 "../src/retro/retro-gamepad.vala"
	if (_tmp1_) {
#line 541 "retro-gamepad.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
#line 112 "../src/retro/retro-gamepad.vala"
		_tmp2_ = self->priv->buttons;
#line 112 "../src/retro/retro-gamepad.vala"
		_tmp2__length1 = self->priv->buttons_length1;
#line 112 "../src/retro/retro-gamepad.vala"
		_tmp2_[button] = FALSE;
#line 550 "retro-gamepad.c"
	}
}

static void
games_retro_gamepad_on_absolute_axis_event (GamesRetroGamepad* self,
                                            ManetteEvent* event)
{
	guint16 axis = 0U;
	gdouble value = 0.0;
	guint16 _tmp0_ = 0U;
	gdouble _tmp1_ = 0.0;
	gboolean _tmp2_;
#line 115 "../src/retro/retro-gamepad.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/retro/retro-gamepad.vala"
	g_return_if_fail (event != NULL);
#line 119 "../src/retro/retro-gamepad.vala"
	_tmp2_ = manette_event_get_absolute (event, &_tmp0_, &_tmp1_);
#line 119 "../src/retro/retro-gamepad.vala"
	axis = _tmp0_;
#line 119 "../src/retro/retro-gamepad.vala"
	value = _tmp1_;
#line 119 "../src/retro/retro-gamepad.vala"
	if (_tmp2_) {
#line 575 "retro-gamepad.c"
		gint16* _tmp3_;
		gint _tmp3__length1;
#line 120 "../src/retro/retro-gamepad.vala"
		_tmp3_ = self->priv->axes;
#line 120 "../src/retro/retro-gamepad.vala"
		_tmp3__length1 = self->priv->axes_length1;
#line 120 "../src/retro/retro-gamepad.vala"
		_tmp3_[axis] = (gint16) (value * G_MAXINT16);
#line 584 "retro-gamepad.c"
	}
}

ManetteDevice*
games_retro_gamepad_get_device (GamesRetroGamepad* self)
{
	ManetteDevice* result;
	ManetteDevice* _tmp0_;
#line 4 "../src/retro/retro-gamepad.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4 "../src/retro/retro-gamepad.vala"
	_tmp0_ = self->priv->_device;
#line 4 "../src/retro/retro-gamepad.vala"
	result = _tmp0_;
#line 4 "../src/retro/retro-gamepad.vala"
	return result;
#line 601 "retro-gamepad.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 4 "../src/retro/retro-gamepad.vala"
	return self ? g_object_ref (self) : NULL;
#line 609 "retro-gamepad.c"
}

static void
games_retro_gamepad_set_device (GamesRetroGamepad* self,
                                ManetteDevice* value)
{
#line 4 "../src/retro/retro-gamepad.vala"
	g_return_if_fail (self != NULL);
#line 4 "../src/retro/retro-gamepad.vala"
	if (games_retro_gamepad_get_device (self) != value) {
#line 620 "retro-gamepad.c"
		ManetteDevice* _tmp0_;
#line 4 "../src/retro/retro-gamepad.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 4 "../src/retro/retro-gamepad.vala"
		_g_object_unref0 (self->priv->_device);
#line 4 "../src/retro/retro-gamepad.vala"
		self->priv->_device = _tmp0_;
#line 4 "../src/retro/retro-gamepad.vala"
		g_object_notify_by_pspec ((GObject *) self, games_retro_gamepad_properties[GAMES_RETRO_GAMEPAD_DEVICE_PROPERTY]);
#line 630 "retro-gamepad.c"
	}
}

gboolean
games_retro_gamepad_get_present_analog_sticks (GamesRetroGamepad* self)
{
	gboolean result;
#line 5 "../src/retro/retro-gamepad.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 5 "../src/retro/retro-gamepad.vala"
	result = self->priv->_present_analog_sticks;
#line 5 "../src/retro/retro-gamepad.vala"
	return result;
#line 644 "retro-gamepad.c"
}

static void
games_retro_gamepad_set_present_analog_sticks (GamesRetroGamepad* self,
                                               gboolean value)
{
#line 5 "../src/retro/retro-gamepad.vala"
	g_return_if_fail (self != NULL);
#line 5 "../src/retro/retro-gamepad.vala"
	if (games_retro_gamepad_get_present_analog_sticks (self) != value) {
#line 5 "../src/retro/retro-gamepad.vala"
		self->priv->_present_analog_sticks = value;
#line 5 "../src/retro/retro-gamepad.vala"
		g_object_notify_by_pspec ((GObject *) self, games_retro_gamepad_properties[GAMES_RETRO_GAMEPAD_PRESENT_ANALOG_STICKS_PROPERTY]);
#line 659 "retro-gamepad.c"
	}
}

static void
_games_retro_gamepad_on_button_press_event_manette_device_button_press_event (ManetteDevice* _sender,
                                                                              ManetteEvent* event,
                                                                              gpointer self)
{
#line 19 "../src/retro/retro-gamepad.vala"
	games_retro_gamepad_on_button_press_event ((GamesRetroGamepad*) self, event);
#line 670 "retro-gamepad.c"
}

static void
_games_retro_gamepad_on_button_release_event_manette_device_button_release_event (ManetteDevice* _sender,
                                                                                  ManetteEvent* event,
                                                                                  gpointer self)
{
#line 20 "../src/retro/retro-gamepad.vala"
	games_retro_gamepad_on_button_release_event ((GamesRetroGamepad*) self, event);
#line 680 "retro-gamepad.c"
}

static void
_games_retro_gamepad_on_absolute_axis_event_manette_device_absolute_axis_event (ManetteDevice* _sender,
                                                                                ManetteEvent* event,
                                                                                gpointer self)
{
#line 21 "../src/retro/retro-gamepad.vala"
	games_retro_gamepad_on_absolute_axis_event ((GamesRetroGamepad*) self, event);
#line 690 "retro-gamepad.c"
}

static GObject *
games_retro_gamepad_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GamesRetroGamepad * self;
	gboolean* _tmp0_;
	gint16* _tmp1_;
	ManetteDevice* _tmp2_;
	ManetteDevice* _tmp3_;
	ManetteDevice* _tmp4_;
#line 15 "../src/retro/retro-gamepad.vala"
	parent_class = G_OBJECT_CLASS (games_retro_gamepad_parent_class);
#line 15 "../src/retro/retro-gamepad.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 15 "../src/retro/retro-gamepad.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_RETRO_GAMEPAD, GamesRetroGamepad);
#line 16 "../src/retro/retro-gamepad.vala"
	_tmp0_ = g_new0 (gboolean, KEY_MAX + 1);
#line 16 "../src/retro/retro-gamepad.vala"
	self->priv->buttons = (g_free (self->priv->buttons), NULL);
#line 16 "../src/retro/retro-gamepad.vala"
	self->priv->buttons = _tmp0_;
#line 16 "../src/retro/retro-gamepad.vala"
	self->priv->buttons_length1 = KEY_MAX + 1;
#line 16 "../src/retro/retro-gamepad.vala"
	self->priv->_buttons_size_ = self->priv->buttons_length1;
#line 17 "../src/retro/retro-gamepad.vala"
	_tmp1_ = g_new0 (gint16, ABS_MAX + 1);
#line 17 "../src/retro/retro-gamepad.vala"
	self->priv->axes = (g_free (self->priv->axes), NULL);
#line 17 "../src/retro/retro-gamepad.vala"
	self->priv->axes = _tmp1_;
#line 17 "../src/retro/retro-gamepad.vala"
	self->priv->axes_length1 = ABS_MAX + 1;
#line 17 "../src/retro/retro-gamepad.vala"
	self->priv->_axes_size_ = self->priv->axes_length1;
#line 19 "../src/retro/retro-gamepad.vala"
	_tmp2_ = self->priv->_device;
#line 19 "../src/retro/retro-gamepad.vala"
	g_signal_connect_object (_tmp2_, "button-press-event", (GCallback) _games_retro_gamepad_on_button_press_event_manette_device_button_press_event, self, 0);
#line 20 "../src/retro/retro-gamepad.vala"
	_tmp3_ = self->priv->_device;
#line 20 "../src/retro/retro-gamepad.vala"
	g_signal_connect_object (_tmp3_, "button-release-event", (GCallback) _games_retro_gamepad_on_button_release_event_manette_device_button_release_event, self, 0);
#line 21 "../src/retro/retro-gamepad.vala"
	_tmp4_ = self->priv->_device;
#line 21 "../src/retro/retro-gamepad.vala"
	g_signal_connect_object (_tmp4_, "absolute-axis-event", (GCallback) _games_retro_gamepad_on_absolute_axis_event_manette_device_absolute_axis_event, self, 0);
#line 15 "../src/retro/retro-gamepad.vala"
	return obj;
#line 746 "retro-gamepad.c"
}

static void
games_retro_gamepad_class_init (GamesRetroGamepadClass * klass,
                                gpointer klass_data)
{
#line 3 "../src/retro/retro-gamepad.vala"
	games_retro_gamepad_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/retro/retro-gamepad.vala"
	g_type_class_adjust_private_offset (klass, &GamesRetroGamepad_private_offset);
#line 3 "../src/retro/retro-gamepad.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_retro_gamepad_get_property;
#line 3 "../src/retro/retro-gamepad.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_games_retro_gamepad_set_property;
#line 3 "../src/retro/retro-gamepad.vala"
	G_OBJECT_CLASS (klass)->constructor = games_retro_gamepad_constructor;
#line 3 "../src/retro/retro-gamepad.vala"
	G_OBJECT_CLASS (klass)->finalize = games_retro_gamepad_finalize;
#line 3 "../src/retro/retro-gamepad.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_RETRO_GAMEPAD_DEVICE_PROPERTY, games_retro_gamepad_properties[GAMES_RETRO_GAMEPAD_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", manette_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3 "../src/retro/retro-gamepad.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_RETRO_GAMEPAD_PRESENT_ANALOG_STICKS_PROPERTY, games_retro_gamepad_properties[GAMES_RETRO_GAMEPAD_PRESENT_ANALOG_STICKS_PROPERTY] = g_param_spec_boolean ("present-analog-sticks", "present-analog-sticks", "present-analog-sticks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 769 "retro-gamepad.c"
}

static void
games_retro_gamepad_retro_controller_interface_init (RetroControllerInterface * iface,
                                                     gpointer iface_data)
{
#line 3 "../src/retro/retro-gamepad.vala"
	games_retro_gamepad_retro_controller_parent_iface = g_type_interface_peek_parent (iface);
#line 3 "../src/retro/retro-gamepad.vala"
	iface->poll = (void (*) (RetroController*)) games_retro_gamepad_real_poll;
#line 3 "../src/retro/retro-gamepad.vala"
	iface->get_input_state = (gint16 (*) (RetroController*, RetroInput*)) games_retro_gamepad_real_get_input_state;
#line 3 "../src/retro/retro-gamepad.vala"
	iface->get_controller_type = (RetroControllerType (*) (RetroController*)) games_retro_gamepad_real_get_controller_type;
#line 3 "../src/retro/retro-gamepad.vala"
	iface->get_capabilities = (guint64 (*) (RetroController*)) games_retro_gamepad_real_get_capabilities;
#line 3 "../src/retro/retro-gamepad.vala"
	iface->set_rumble_state = (gboolean (*) (RetroController*, RetroRumbleEffect, guint16)) games_retro_gamepad_real_set_rumble_state;
#line 788 "retro-gamepad.c"
}

static void
games_retro_gamepad_instance_init (GamesRetroGamepad * self,
                                   gpointer klass)
{
#line 3 "../src/retro/retro-gamepad.vala"
	self->priv = games_retro_gamepad_get_instance_private (self);
#line 797 "retro-gamepad.c"
}

static void
games_retro_gamepad_finalize (GObject * obj)
{
	GamesRetroGamepad * self;
#line 3 "../src/retro/retro-gamepad.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_RETRO_GAMEPAD, GamesRetroGamepad);
#line 4 "../src/retro/retro-gamepad.vala"
	_g_object_unref0 (self->priv->_device);
#line 7 "../src/retro/retro-gamepad.vala"
	self->priv->buttons = (g_free (self->priv->buttons), NULL);
#line 8 "../src/retro/retro-gamepad.vala"
	self->priv->axes = (g_free (self->priv->axes), NULL);
#line 3 "../src/retro/retro-gamepad.vala"
	G_OBJECT_CLASS (games_retro_gamepad_parent_class)->finalize (obj);
#line 814 "retro-gamepad.c"
}

GType
games_retro_gamepad_get_type (void)
{
	static volatile gsize games_retro_gamepad_type_id__volatile = 0;
	if (g_once_init_enter (&games_retro_gamepad_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GamesRetroGamepadClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_retro_gamepad_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesRetroGamepad), 0, (GInstanceInitFunc) games_retro_gamepad_instance_init, NULL };
		static const GInterfaceInfo retro_controller_info = { (GInterfaceInitFunc) games_retro_gamepad_retro_controller_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType games_retro_gamepad_type_id;
		games_retro_gamepad_type_id = g_type_register_static (G_TYPE_OBJECT, "GamesRetroGamepad", &g_define_type_info, 0);
		g_type_add_interface_static (games_retro_gamepad_type_id, retro_controller_get_type (), &retro_controller_info);
		GamesRetroGamepad_private_offset = g_type_add_instance_private (games_retro_gamepad_type_id, sizeof (GamesRetroGamepadPrivate));
		g_once_init_leave (&games_retro_gamepad_type_id__volatile, games_retro_gamepad_type_id);
	}
	return games_retro_gamepad_type_id__volatile;
}

static void
_vala_games_retro_gamepad_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GamesRetroGamepad * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_RETRO_GAMEPAD, GamesRetroGamepad);
#line 3 "../src/retro/retro-gamepad.vala"
	switch (property_id) {
#line 3 "../src/retro/retro-gamepad.vala"
		case GAMES_RETRO_GAMEPAD_DEVICE_PROPERTY:
#line 3 "../src/retro/retro-gamepad.vala"
		g_value_set_object (value, games_retro_gamepad_get_device (self));
#line 3 "../src/retro/retro-gamepad.vala"
		break;
#line 3 "../src/retro/retro-gamepad.vala"
		case GAMES_RETRO_GAMEPAD_PRESENT_ANALOG_STICKS_PROPERTY:
#line 3 "../src/retro/retro-gamepad.vala"
		g_value_set_boolean (value, games_retro_gamepad_get_present_analog_sticks (self));
#line 3 "../src/retro/retro-gamepad.vala"
		break;
#line 855 "retro-gamepad.c"
		default:
#line 3 "../src/retro/retro-gamepad.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/retro/retro-gamepad.vala"
		break;
#line 861 "retro-gamepad.c"
	}
}

static void
_vala_games_retro_gamepad_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	GamesRetroGamepad * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_RETRO_GAMEPAD, GamesRetroGamepad);
#line 3 "../src/retro/retro-gamepad.vala"
	switch (property_id) {
#line 3 "../src/retro/retro-gamepad.vala"
		case GAMES_RETRO_GAMEPAD_DEVICE_PROPERTY:
#line 3 "../src/retro/retro-gamepad.vala"
		games_retro_gamepad_set_device (self, g_value_get_object (value));
#line 3 "../src/retro/retro-gamepad.vala"
		break;
#line 3 "../src/retro/retro-gamepad.vala"
		case GAMES_RETRO_GAMEPAD_PRESENT_ANALOG_STICKS_PROPERTY:
#line 3 "../src/retro/retro-gamepad.vala"
		games_retro_gamepad_set_present_analog_sticks (self, g_value_get_boolean (value));
#line 3 "../src/retro/retro-gamepad.vala"
		break;
#line 887 "retro-gamepad.c"
		default:
#line 3 "../src/retro/retro-gamepad.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 3 "../src/retro/retro-gamepad.vala"
		break;
#line 893 "retro-gamepad.c"
	}
}

