/* unicode.c generated by valac 0.44.3, the Vala compiler
 * generated from unicode.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

typedef enum  {
	GAMES_UNICODE_ENCODING_UTF_32BE,
	GAMES_UNICODE_ENCODING_UTF_32LE,
	GAMES_UNICODE_ENCODING_UTF_16BE,
	GAMES_UNICODE_ENCODING_UTF_16LE,
	GAMES_UNICODE_ENCODING_UTF_8
} GamesUnicodeEncoding;

#define GAMES_UNICODE_TYPE_ENCODING (games_unicode_encoding_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

GType games_unicode_encoding_get_type (void) G_GNUC_CONST;
gchar* games_unicode_encoding_to_string (GamesUnicodeEncoding self);
GamesUnicodeEncoding games_unicode_parse_encoding (GFileInputStream* stream,
                                                   gint* bom_length,
                                                   GError** error);
GInputStream* games_unicode_read (GFile* file,
                                  GamesUnicodeEncoding encoding,
                                  GError** error);

gchar*
games_unicode_encoding_to_string (GamesUnicodeEncoding self)
{
	gchar* result = NULL;
#line 12 "../src/utils/unicode.vala"
	switch (self) {
#line 12 "../src/utils/unicode.vala"
		case GAMES_UNICODE_ENCODING_UTF_32BE:
#line 42 "unicode.c"
		{
			gchar* _tmp0_;
#line 14 "../src/utils/unicode.vala"
			_tmp0_ = g_strdup ("utf-32be");
#line 14 "../src/utils/unicode.vala"
			result = _tmp0_;
#line 14 "../src/utils/unicode.vala"
			return result;
#line 51 "unicode.c"
		}
#line 12 "../src/utils/unicode.vala"
		case GAMES_UNICODE_ENCODING_UTF_32LE:
#line 55 "unicode.c"
		{
			gchar* _tmp1_;
#line 16 "../src/utils/unicode.vala"
			_tmp1_ = g_strdup ("utf-32le");
#line 16 "../src/utils/unicode.vala"
			result = _tmp1_;
#line 16 "../src/utils/unicode.vala"
			return result;
#line 64 "unicode.c"
		}
#line 12 "../src/utils/unicode.vala"
		case GAMES_UNICODE_ENCODING_UTF_16BE:
#line 68 "unicode.c"
		{
			gchar* _tmp2_;
#line 18 "../src/utils/unicode.vala"
			_tmp2_ = g_strdup ("utf-16be");
#line 18 "../src/utils/unicode.vala"
			result = _tmp2_;
#line 18 "../src/utils/unicode.vala"
			return result;
#line 77 "unicode.c"
		}
#line 12 "../src/utils/unicode.vala"
		case GAMES_UNICODE_ENCODING_UTF_16LE:
#line 81 "unicode.c"
		{
			gchar* _tmp3_;
#line 20 "../src/utils/unicode.vala"
			_tmp3_ = g_strdup ("utf-16le");
#line 20 "../src/utils/unicode.vala"
			result = _tmp3_;
#line 20 "../src/utils/unicode.vala"
			return result;
#line 90 "unicode.c"
		}
		default:
		{
			gchar* _tmp4_;
#line 22 "../src/utils/unicode.vala"
			_tmp4_ = g_strdup ("utf-8");
#line 22 "../src/utils/unicode.vala"
			result = _tmp4_;
#line 22 "../src/utils/unicode.vala"
			return result;
#line 101 "unicode.c"
		}
	}
}

GType
games_unicode_encoding_get_type (void)
{
	static volatile gsize games_unicode_encoding_type_id__volatile = 0;
	if (g_once_init_enter (&games_unicode_encoding_type_id__volatile)) {
		static const GEnumValue values[] = {{GAMES_UNICODE_ENCODING_UTF_32BE, "GAMES_UNICODE_ENCODING_UTF_32BE", "utf-32be"}, {GAMES_UNICODE_ENCODING_UTF_32LE, "GAMES_UNICODE_ENCODING_UTF_32LE", "utf-32le"}, {GAMES_UNICODE_ENCODING_UTF_16BE, "GAMES_UNICODE_ENCODING_UTF_16BE", "utf-16be"}, {GAMES_UNICODE_ENCODING_UTF_16LE, "GAMES_UNICODE_ENCODING_UTF_16LE", "utf-16le"}, {GAMES_UNICODE_ENCODING_UTF_8, "GAMES_UNICODE_ENCODING_UTF_8", "utf-8"}, {0, NULL, NULL}};
		GType games_unicode_encoding_type_id;
		games_unicode_encoding_type_id = g_enum_register_static ("GamesUnicodeEncoding", values);
		g_once_init_leave (&games_unicode_encoding_type_id__volatile, games_unicode_encoding_type_id);
	}
	return games_unicode_encoding_type_id__volatile;
}

GamesUnicodeEncoding
games_unicode_parse_encoding (GFileInputStream* stream,
                              gint* bom_length,
                              GError** error)
{
	gint _vala_bom_length = 0;
	GamesUnicodeEncoding result = 0;
	guint8* c = NULL;
	guint8* _tmp0_;
	gint c_length1;
	gint _c_size_;
	gssize size = 0L;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint32 bom = 0U;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8 _tmp3_;
	guint8* _tmp4_;
	gint _tmp4__length1;
	guint8 _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8 _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	guint8 _tmp9_;
	GError* _inner_error0_ = NULL;
#line 27 "../src/utils/unicode.vala"
	g_return_val_if_fail (stream != NULL, 0);
#line 28 "../src/utils/unicode.vala"
	G_FILE_INPUT_STREAM_GET_CLASS (stream)->seek (stream, (gint64) 0, G_SEEK_SET, NULL, &_inner_error0_);
#line 28 "../src/utils/unicode.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28 "../src/utils/unicode.vala"
		g_propagate_error (error, _inner_error0_);
#line 28 "../src/utils/unicode.vala"
		return 0;
#line 157 "unicode.c"
	}
#line 30 "../src/utils/unicode.vala"
	_tmp0_ = g_new0 (guint8, 4);
#line 30 "../src/utils/unicode.vala"
	_tmp0_[0] = (guint8) 0;
#line 30 "../src/utils/unicode.vala"
	_tmp0_[1] = (guint8) 0;
#line 30 "../src/utils/unicode.vala"
	_tmp0_[2] = (guint8) 0;
#line 30 "../src/utils/unicode.vala"
	_tmp0_[3] = (guint8) 0;
#line 30 "../src/utils/unicode.vala"
	c = _tmp0_;
#line 30 "../src/utils/unicode.vala"
	c_length1 = 4;
#line 30 "../src/utils/unicode.vala"
	_c_size_ = c_length1;
#line 31 "../src/utils/unicode.vala"
	_tmp1_ = c;
#line 31 "../src/utils/unicode.vala"
	_tmp1__length1 = c_length1;
#line 31 "../src/utils/unicode.vala"
	size = g_input_stream_read ((GInputStream*) stream, _tmp1_, (gsize) _tmp1__length1, NULL, &_inner_error0_);
#line 31 "../src/utils/unicode.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../src/utils/unicode.vala"
		g_propagate_error (error, _inner_error0_);
#line 31 "../src/utils/unicode.vala"
		c = (g_free (c), NULL);
#line 31 "../src/utils/unicode.vala"
		return 0;
#line 189 "unicode.c"
	}
#line 32 "../src/utils/unicode.vala"
	if (size < ((gssize) 4)) {
#line 33 "../src/utils/unicode.vala"
		_vala_bom_length = 0;
#line 35 "../src/utils/unicode.vala"
		result = GAMES_UNICODE_ENCODING_UTF_8;
#line 35 "../src/utils/unicode.vala"
		c = (g_free (c), NULL);
#line 35 "../src/utils/unicode.vala"
		if (bom_length) {
#line 35 "../src/utils/unicode.vala"
			*bom_length = _vala_bom_length;
#line 203 "unicode.c"
		}
#line 35 "../src/utils/unicode.vala"
		return result;
#line 207 "unicode.c"
	}
#line 38 "../src/utils/unicode.vala"
	_tmp2_ = c;
#line 38 "../src/utils/unicode.vala"
	_tmp2__length1 = c_length1;
#line 38 "../src/utils/unicode.vala"
	_tmp3_ = _tmp2_[0];
#line 38 "../src/utils/unicode.vala"
	_tmp4_ = c;
#line 38 "../src/utils/unicode.vala"
	_tmp4__length1 = c_length1;
#line 38 "../src/utils/unicode.vala"
	_tmp5_ = _tmp4_[1];
#line 38 "../src/utils/unicode.vala"
	_tmp6_ = c;
#line 38 "../src/utils/unicode.vala"
	_tmp6__length1 = c_length1;
#line 38 "../src/utils/unicode.vala"
	_tmp7_ = _tmp6_[2];
#line 38 "../src/utils/unicode.vala"
	_tmp8_ = c;
#line 38 "../src/utils/unicode.vala"
	_tmp8__length1 = c_length1;
#line 38 "../src/utils/unicode.vala"
	_tmp9_ = _tmp8_[3];
#line 38 "../src/utils/unicode.vala"
	bom = (guint32) (((_tmp3_ | (_tmp5_ << 8)) | (_tmp7_ << 16)) | (_tmp9_ << 24));
#line 39 "../src/utils/unicode.vala"
	if (((gint64) bom) == 0xfffe0000LL) {
#line 40 "../src/utils/unicode.vala"
		_vala_bom_length = 4;
#line 42 "../src/utils/unicode.vala"
		result = GAMES_UNICODE_ENCODING_UTF_32BE;
#line 42 "../src/utils/unicode.vala"
		c = (g_free (c), NULL);
#line 42 "../src/utils/unicode.vala"
		if (bom_length) {
#line 42 "../src/utils/unicode.vala"
			*bom_length = _vala_bom_length;
#line 247 "unicode.c"
		}
#line 42 "../src/utils/unicode.vala"
		return result;
#line 251 "unicode.c"
	} else {
#line 44 "../src/utils/unicode.vala"
		if (bom == ((guint32) 0x0000feff)) {
#line 45 "../src/utils/unicode.vala"
			_vala_bom_length = 4;
#line 47 "../src/utils/unicode.vala"
			result = GAMES_UNICODE_ENCODING_UTF_32LE;
#line 47 "../src/utils/unicode.vala"
			c = (g_free (c), NULL);
#line 47 "../src/utils/unicode.vala"
			if (bom_length) {
#line 47 "../src/utils/unicode.vala"
				*bom_length = _vala_bom_length;
#line 265 "unicode.c"
			}
#line 47 "../src/utils/unicode.vala"
			return result;
#line 269 "unicode.c"
		} else {
#line 49 "../src/utils/unicode.vala"
			if ((bom & 0xffff) == ((guint32) 0xfffe)) {
#line 50 "../src/utils/unicode.vala"
				_vala_bom_length = 2;
#line 52 "../src/utils/unicode.vala"
				result = GAMES_UNICODE_ENCODING_UTF_16BE;
#line 52 "../src/utils/unicode.vala"
				c = (g_free (c), NULL);
#line 52 "../src/utils/unicode.vala"
				if (bom_length) {
#line 52 "../src/utils/unicode.vala"
					*bom_length = _vala_bom_length;
#line 283 "unicode.c"
				}
#line 52 "../src/utils/unicode.vala"
				return result;
#line 287 "unicode.c"
			} else {
#line 54 "../src/utils/unicode.vala"
				if ((bom & 0xffff) == ((guint32) 0xfeff)) {
#line 55 "../src/utils/unicode.vala"
					_vala_bom_length = 2;
#line 57 "../src/utils/unicode.vala"
					result = GAMES_UNICODE_ENCODING_UTF_16LE;
#line 57 "../src/utils/unicode.vala"
					c = (g_free (c), NULL);
#line 57 "../src/utils/unicode.vala"
					if (bom_length) {
#line 57 "../src/utils/unicode.vala"
						*bom_length = _vala_bom_length;
#line 301 "unicode.c"
					}
#line 57 "../src/utils/unicode.vala"
					return result;
#line 305 "unicode.c"
				} else {
#line 59 "../src/utils/unicode.vala"
					if ((bom & 0xffffff) == ((guint32) 0xbfbbef)) {
#line 60 "../src/utils/unicode.vala"
						_vala_bom_length = 3;
#line 62 "../src/utils/unicode.vala"
						result = GAMES_UNICODE_ENCODING_UTF_8;
#line 62 "../src/utils/unicode.vala"
						c = (g_free (c), NULL);
#line 62 "../src/utils/unicode.vala"
						if (bom_length) {
#line 62 "../src/utils/unicode.vala"
							*bom_length = _vala_bom_length;
#line 319 "unicode.c"
						}
#line 62 "../src/utils/unicode.vala"
						return result;
#line 323 "unicode.c"
					}
				}
			}
		}
	}
#line 65 "../src/utils/unicode.vala"
	_vala_bom_length = 0;
#line 67 "../src/utils/unicode.vala"
	result = GAMES_UNICODE_ENCODING_UTF_8;
#line 67 "../src/utils/unicode.vala"
	c = (g_free (c), NULL);
#line 67 "../src/utils/unicode.vala"
	if (bom_length) {
#line 67 "../src/utils/unicode.vala"
		*bom_length = _vala_bom_length;
#line 339 "unicode.c"
	}
#line 67 "../src/utils/unicode.vala"
	return result;
#line 343 "unicode.c"
}

GInputStream*
games_unicode_read (GFile* file,
                    GamesUnicodeEncoding encoding,
                    GError** error)
{
	GInputStream* result = NULL;
	GFileInputStream* stream = NULL;
	GFileInputStream* _tmp0_;
	gint bom_length = 0;
	GamesUnicodeEncoding src_encoding = 0;
	GFileInputStream* _tmp1_;
	gint _tmp2_ = 0;
	GamesUnicodeEncoding _tmp3_;
	GFileInputStream* _tmp4_;
	GCharsetConverter* converter = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GamesUnicodeEncoding _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GCharsetConverter* _tmp10_;
	GCharsetConverter* _tmp11_;
	GFileInputStream* _tmp12_;
	GCharsetConverter* _tmp13_;
	GConverterInputStream* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 70 "../src/utils/unicode.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 71 "../src/utils/unicode.vala"
	_tmp0_ = g_file_read (file, NULL, &_inner_error0_);
#line 71 "../src/utils/unicode.vala"
	stream = _tmp0_;
#line 71 "../src/utils/unicode.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/utils/unicode.vala"
		g_propagate_error (error, _inner_error0_);
#line 71 "../src/utils/unicode.vala"
		return NULL;
#line 384 "unicode.c"
	}
#line 72 "../src/utils/unicode.vala"
	bom_length = 0;
#line 73 "../src/utils/unicode.vala"
	_tmp1_ = stream;
#line 73 "../src/utils/unicode.vala"
	_tmp3_ = games_unicode_parse_encoding (_tmp1_, &_tmp2_, &_inner_error0_);
#line 73 "../src/utils/unicode.vala"
	bom_length = _tmp2_;
#line 73 "../src/utils/unicode.vala"
	src_encoding = _tmp3_;
#line 73 "../src/utils/unicode.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/utils/unicode.vala"
		g_propagate_error (error, _inner_error0_);
#line 73 "../src/utils/unicode.vala"
		_g_object_unref0 (stream);
#line 73 "../src/utils/unicode.vala"
		return NULL;
#line 404 "unicode.c"
	}
#line 74 "../src/utils/unicode.vala"
	_tmp4_ = stream;
#line 74 "../src/utils/unicode.vala"
	G_FILE_INPUT_STREAM_GET_CLASS (_tmp4_)->seek (_tmp4_, (gint64) bom_length, G_SEEK_SET, NULL, &_inner_error0_);
#line 74 "../src/utils/unicode.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/utils/unicode.vala"
		g_propagate_error (error, _inner_error0_);
#line 74 "../src/utils/unicode.vala"
		_g_object_unref0 (stream);
#line 74 "../src/utils/unicode.vala"
		return NULL;
#line 418 "unicode.c"
	}
#line 76 "../src/utils/unicode.vala"
	if (encoding == GAMES_UNICODE_ENCODING_UTF_8) {
#line 77 "../src/utils/unicode.vala"
		result = (GInputStream*) stream;
#line 77 "../src/utils/unicode.vala"
		return result;
#line 426 "unicode.c"
	}
#line 79 "../src/utils/unicode.vala"
	_tmp5_ = games_unicode_encoding_to_string (encoding);
#line 79 "../src/utils/unicode.vala"
	_tmp6_ = _tmp5_;
#line 79 "../src/utils/unicode.vala"
	_tmp7_ = src_encoding;
#line 79 "../src/utils/unicode.vala"
	_tmp8_ = games_unicode_encoding_to_string (_tmp7_);
#line 79 "../src/utils/unicode.vala"
	_tmp9_ = _tmp8_;
#line 79 "../src/utils/unicode.vala"
	_tmp10_ = g_charset_converter_new (_tmp6_, _tmp9_, &_inner_error0_);
#line 79 "../src/utils/unicode.vala"
	_tmp11_ = _tmp10_;
#line 79 "../src/utils/unicode.vala"
	_g_free0 (_tmp9_);
#line 79 "../src/utils/unicode.vala"
	_g_free0 (_tmp6_);
#line 79 "../src/utils/unicode.vala"
	converter = _tmp11_;
#line 79 "../src/utils/unicode.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/utils/unicode.vala"
		g_propagate_error (error, _inner_error0_);
#line 79 "../src/utils/unicode.vala"
		_g_object_unref0 (stream);
#line 79 "../src/utils/unicode.vala"
		return NULL;
#line 456 "unicode.c"
	}
#line 81 "../src/utils/unicode.vala"
	_tmp12_ = stream;
#line 81 "../src/utils/unicode.vala"
	_tmp13_ = converter;
#line 81 "../src/utils/unicode.vala"
	_tmp14_ = (GConverterInputStream*) g_converter_input_stream_new ((GInputStream*) _tmp12_, (GConverter*) _tmp13_);
#line 81 "../src/utils/unicode.vala"
	result = (GInputStream*) _tmp14_;
#line 81 "../src/utils/unicode.vala"
	_g_object_unref0 (converter);
#line 81 "../src/utils/unicode.vala"
	_g_object_unref0 (stream);
#line 81 "../src/utils/unicode.vala"
	return result;
#line 472 "unicode.c"
}

